// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/baremetalsolution/v2/baremetalsolution.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_BAREMETALSOLUTION_V2_INTERNAL_BARE_METAL_SOLUTION_STUB_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_BAREMETALSOLUTION_V2_INTERNAL_BARE_METAL_SOLUTION_STUB_H

#include "google/cloud/completion_queue.h"
#include "google/cloud/future.h"
#include "google/cloud/status_or.h"
#include "google/cloud/version.h"
#include <google/cloud/baremetalsolution/v2/baremetalsolution.grpc.pb.h>
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace baremetalsolution_v2_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class BareMetalSolutionStub {
 public:
  virtual ~BareMetalSolutionStub() = 0;

  virtual StatusOr<google::cloud::baremetalsolution::v2::ListInstancesResponse>
  ListInstances(
      grpc::ClientContext& context,
      google::cloud::baremetalsolution::v2::ListInstancesRequest const&
          request) = 0;

  virtual StatusOr<google::cloud::baremetalsolution::v2::Instance> GetInstance(
      grpc::ClientContext& context,
      google::cloud::baremetalsolution::v2::GetInstanceRequest const&
          request) = 0;

  virtual future<StatusOr<google::longrunning::Operation>> AsyncUpdateInstance(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::baremetalsolution::v2::UpdateInstanceRequest const&
          request) = 0;

  virtual future<StatusOr<google::longrunning::Operation>> AsyncResetInstance(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::baremetalsolution::v2::ResetInstanceRequest const&
          request) = 0;

  virtual future<StatusOr<google::longrunning::Operation>> AsyncStartInstance(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::baremetalsolution::v2::StartInstanceRequest const&
          request) = 0;

  virtual future<StatusOr<google::longrunning::Operation>> AsyncStopInstance(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::baremetalsolution::v2::StopInstanceRequest const&
          request) = 0;

  virtual future<StatusOr<google::longrunning::Operation>> AsyncDetachLun(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::baremetalsolution::v2::DetachLunRequest const&
          request) = 0;

  virtual StatusOr<google::cloud::baremetalsolution::v2::ListVolumesResponse>
  ListVolumes(grpc::ClientContext& context,
              google::cloud::baremetalsolution::v2::ListVolumesRequest const&
                  request) = 0;

  virtual StatusOr<google::cloud::baremetalsolution::v2::Volume> GetVolume(
      grpc::ClientContext& context,
      google::cloud::baremetalsolution::v2::GetVolumeRequest const&
          request) = 0;

  virtual future<StatusOr<google::longrunning::Operation>> AsyncUpdateVolume(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::baremetalsolution::v2::UpdateVolumeRequest const&
          request) = 0;

  virtual future<StatusOr<google::longrunning::Operation>> AsyncResizeVolume(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::baremetalsolution::v2::ResizeVolumeRequest const&
          request) = 0;

  virtual StatusOr<google::cloud::baremetalsolution::v2::ListNetworksResponse>
  ListNetworks(grpc::ClientContext& context,
               google::cloud::baremetalsolution::v2::ListNetworksRequest const&
                   request) = 0;

  virtual StatusOr<
      google::cloud::baremetalsolution::v2::ListNetworkUsageResponse>
  ListNetworkUsage(
      grpc::ClientContext& context,
      google::cloud::baremetalsolution::v2::ListNetworkUsageRequest const&
          request) = 0;

  virtual StatusOr<google::cloud::baremetalsolution::v2::Network> GetNetwork(
      grpc::ClientContext& context,
      google::cloud::baremetalsolution::v2::GetNetworkRequest const&
          request) = 0;

  virtual future<StatusOr<google::longrunning::Operation>> AsyncUpdateNetwork(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::baremetalsolution::v2::UpdateNetworkRequest const&
          request) = 0;

  virtual StatusOr<google::cloud::baremetalsolution::v2::Lun> GetLun(
      grpc::ClientContext& context,
      google::cloud::baremetalsolution::v2::GetLunRequest const& request) = 0;

  virtual StatusOr<google::cloud::baremetalsolution::v2::ListLunsResponse>
  ListLuns(
      grpc::ClientContext& context,
      google::cloud::baremetalsolution::v2::ListLunsRequest const& request) = 0;

  virtual StatusOr<google::cloud::baremetalsolution::v2::NfsShare> GetNfsShare(
      grpc::ClientContext& context,
      google::cloud::baremetalsolution::v2::GetNfsShareRequest const&
          request) = 0;

  virtual StatusOr<google::cloud::baremetalsolution::v2::ListNfsSharesResponse>
  ListNfsShares(
      grpc::ClientContext& context,
      google::cloud::baremetalsolution::v2::ListNfsSharesRequest const&
          request) = 0;

  virtual future<StatusOr<google::longrunning::Operation>> AsyncUpdateNfsShare(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::baremetalsolution::v2::UpdateNfsShareRequest const&
          request) = 0;

  virtual future<StatusOr<google::longrunning::Operation>> AsyncGetOperation(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::longrunning::GetOperationRequest const& request) = 0;

  virtual future<Status> AsyncCancelOperation(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::longrunning::CancelOperationRequest const& request) = 0;
};

class DefaultBareMetalSolutionStub : public BareMetalSolutionStub {
 public:
  DefaultBareMetalSolutionStub(
      std::unique_ptr<google::cloud::baremetalsolution::v2::BareMetalSolution::
                          StubInterface>
          grpc_stub,
      std::unique_ptr<google::longrunning::Operations::StubInterface>
          operations)
      : grpc_stub_(std::move(grpc_stub)), operations_(std::move(operations)) {}

  StatusOr<google::cloud::baremetalsolution::v2::ListInstancesResponse>
  ListInstances(
      grpc::ClientContext& client_context,
      google::cloud::baremetalsolution::v2::ListInstancesRequest const& request)
      override;

  StatusOr<google::cloud::baremetalsolution::v2::Instance> GetInstance(
      grpc::ClientContext& client_context,
      google::cloud::baremetalsolution::v2::GetInstanceRequest const& request)
      override;

  future<StatusOr<google::longrunning::Operation>> AsyncUpdateInstance(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::baremetalsolution::v2::UpdateInstanceRequest const&
          request) override;

  future<StatusOr<google::longrunning::Operation>> AsyncResetInstance(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::baremetalsolution::v2::ResetInstanceRequest const& request)
      override;

  future<StatusOr<google::longrunning::Operation>> AsyncStartInstance(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::baremetalsolution::v2::StartInstanceRequest const& request)
      override;

  future<StatusOr<google::longrunning::Operation>> AsyncStopInstance(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::baremetalsolution::v2::StopInstanceRequest const& request)
      override;

  future<StatusOr<google::longrunning::Operation>> AsyncDetachLun(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::baremetalsolution::v2::DetachLunRequest const& request)
      override;

  StatusOr<google::cloud::baremetalsolution::v2::ListVolumesResponse>
  ListVolumes(grpc::ClientContext& client_context,
              google::cloud::baremetalsolution::v2::ListVolumesRequest const&
                  request) override;

  StatusOr<google::cloud::baremetalsolution::v2::Volume> GetVolume(
      grpc::ClientContext& client_context,
      google::cloud::baremetalsolution::v2::GetVolumeRequest const& request)
      override;

  future<StatusOr<google::longrunning::Operation>> AsyncUpdateVolume(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::baremetalsolution::v2::UpdateVolumeRequest const& request)
      override;

  future<StatusOr<google::longrunning::Operation>> AsyncResizeVolume(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::baremetalsolution::v2::ResizeVolumeRequest const& request)
      override;

  StatusOr<google::cloud::baremetalsolution::v2::ListNetworksResponse>
  ListNetworks(grpc::ClientContext& client_context,
               google::cloud::baremetalsolution::v2::ListNetworksRequest const&
                   request) override;

  StatusOr<google::cloud::baremetalsolution::v2::ListNetworkUsageResponse>
  ListNetworkUsage(
      grpc::ClientContext& client_context,
      google::cloud::baremetalsolution::v2::ListNetworkUsageRequest const&
          request) override;

  StatusOr<google::cloud::baremetalsolution::v2::Network> GetNetwork(
      grpc::ClientContext& client_context,
      google::cloud::baremetalsolution::v2::GetNetworkRequest const& request)
      override;

  future<StatusOr<google::longrunning::Operation>> AsyncUpdateNetwork(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::baremetalsolution::v2::UpdateNetworkRequest const& request)
      override;

  StatusOr<google::cloud::baremetalsolution::v2::Lun> GetLun(
      grpc::ClientContext& client_context,
      google::cloud::baremetalsolution::v2::GetLunRequest const& request)
      override;

  StatusOr<google::cloud::baremetalsolution::v2::ListLunsResponse> ListLuns(
      grpc::ClientContext& client_context,
      google::cloud::baremetalsolution::v2::ListLunsRequest const& request)
      override;

  StatusOr<google::cloud::baremetalsolution::v2::NfsShare> GetNfsShare(
      grpc::ClientContext& client_context,
      google::cloud::baremetalsolution::v2::GetNfsShareRequest const& request)
      override;

  StatusOr<google::cloud::baremetalsolution::v2::ListNfsSharesResponse>
  ListNfsShares(
      grpc::ClientContext& client_context,
      google::cloud::baremetalsolution::v2::ListNfsSharesRequest const& request)
      override;

  future<StatusOr<google::longrunning::Operation>> AsyncUpdateNfsShare(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::baremetalsolution::v2::UpdateNfsShareRequest const&
          request) override;

  future<StatusOr<google::longrunning::Operation>> AsyncGetOperation(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::longrunning::GetOperationRequest const& request) override;

  future<Status> AsyncCancelOperation(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::longrunning::CancelOperationRequest const& request) override;

 private:
  std::unique_ptr<
      google::cloud::baremetalsolution::v2::BareMetalSolution::StubInterface>
      grpc_stub_;
  std::unique_ptr<google::longrunning::Operations::StubInterface> operations_;
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace baremetalsolution_v2_internal
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_BAREMETALSOLUTION_V2_INTERNAL_BARE_METAL_SOLUTION_STUB_H
