// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source:
// google/cloud/beyondcorp/clientconnectorservices/v1/client_connector_services_service.proto

#include "google/cloud/beyondcorp/clientconnectorservices/v1/internal/client_connector_services_option_defaults.h"
#include "google/cloud/beyondcorp/clientconnectorservices/v1/client_connector_services_connection.h"
#include "google/cloud/beyondcorp/clientconnectorservices/v1/client_connector_services_options.h"
#include "google/cloud/internal/populate_common_options.h"
#include "google/cloud/internal/populate_grpc_options.h"
#include <memory>

namespace google {
namespace cloud {
namespace beyondcorp_clientconnectorservices_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

namespace {
auto constexpr kBackoffScaling = 2.0;
}  // namespace

Options ClientConnectorServicesServiceDefaultOptions(Options options) {
  options = google::cloud::internal::PopulateCommonOptions(
      std::move(options),
      "GOOGLE_CLOUD_CPP_CLIENT_CONNECTOR_SERVICES_SERVICE_ENDPOINT", "",
      "GOOGLE_CLOUD_CPP_CLIENT_CONNECTOR_SERVICES_SERVICE_AUTHORITY",
      "beyondcorp.googleapis.com");
  options =
      google::cloud::internal::PopulateGrpcOptions(std::move(options), "");
  if (!options.has<beyondcorp_clientconnectorservices_v1::
                       ClientConnectorServicesServiceRetryPolicyOption>()) {
    options.set<beyondcorp_clientconnectorservices_v1::
                    ClientConnectorServicesServiceRetryPolicyOption>(
        beyondcorp_clientconnectorservices_v1::
            ClientConnectorServicesServiceLimitedTimeRetryPolicy(
                std::chrono::minutes(30))
                .clone());
  }
  if (!options.has<beyondcorp_clientconnectorservices_v1::
                       ClientConnectorServicesServiceBackoffPolicyOption>()) {
    options.set<beyondcorp_clientconnectorservices_v1::
                    ClientConnectorServicesServiceBackoffPolicyOption>(
        ExponentialBackoffPolicy(
            std::chrono::seconds(0), std::chrono::seconds(1),
            std::chrono::minutes(5), kBackoffScaling, kBackoffScaling)
            .clone());
  }
  if (!options.has<beyondcorp_clientconnectorservices_v1::
                       ClientConnectorServicesServicePollingPolicyOption>()) {
    options.set<beyondcorp_clientconnectorservices_v1::
                    ClientConnectorServicesServicePollingPolicyOption>(
        GenericPollingPolicy<
            beyondcorp_clientconnectorservices_v1::
                ClientConnectorServicesServiceRetryPolicyOption::Type,
            beyondcorp_clientconnectorservices_v1::
                ClientConnectorServicesServiceBackoffPolicyOption::Type>(
            options
                .get<beyondcorp_clientconnectorservices_v1::
                         ClientConnectorServicesServiceRetryPolicyOption>()
                ->clone(),
            ExponentialBackoffPolicy(std::chrono::seconds(1),
                                     std::chrono::minutes(5), kBackoffScaling)
                .clone())
            .clone());
  }
  if (!options.has<
          beyondcorp_clientconnectorservices_v1::
              ClientConnectorServicesServiceConnectionIdempotencyPolicyOption>()) {
    options.set<
        beyondcorp_clientconnectorservices_v1::
            ClientConnectorServicesServiceConnectionIdempotencyPolicyOption>(
        beyondcorp_clientconnectorservices_v1::
            MakeDefaultClientConnectorServicesServiceConnectionIdempotencyPolicy());
  }

  return options;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace beyondcorp_clientconnectorservices_v1_internal
}  // namespace cloud
}  // namespace google
