// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source:
// google/cloud/beyondcorp/clientconnectorservices/v1/client_connector_services_service.proto

#include "google/cloud/beyondcorp/clientconnectorservices/v1/internal/client_connector_services_tracing_connection.h"
#include "google/cloud/internal/opentelemetry.h"
#include "google/cloud/internal/traced_stream_range.h"
#include <memory>

namespace google {
namespace cloud {
namespace beyondcorp_clientconnectorservices_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

ClientConnectorServicesServiceTracingConnection::
    ClientConnectorServicesServiceTracingConnection(
        std::shared_ptr<beyondcorp_clientconnectorservices_v1::
                            ClientConnectorServicesServiceConnection>
            child)
    : child_(std::move(child)) {}

StreamRange<google::cloud::beyondcorp::clientconnectorservices::v1::
                ClientConnectorService>
ClientConnectorServicesServiceTracingConnection::ListClientConnectorServices(
    google::cloud::beyondcorp::clientconnectorservices::v1::
        ListClientConnectorServicesRequest request) {
  auto span = internal::MakeSpan(
      "beyondcorp_clientconnectorservices_v1::"
      "ClientConnectorServicesServiceConnection::ListClientConnectorServices");
  auto scope = opentelemetry::trace::Scope(span);
  auto sr = child_->ListClientConnectorServices(std::move(request));
  return internal::MakeTracedStreamRange<
      google::cloud::beyondcorp::clientconnectorservices::v1::
          ClientConnectorService>(std::move(span), std::move(sr));
}

StatusOr<google::cloud::beyondcorp::clientconnectorservices::v1::
             ClientConnectorService>
ClientConnectorServicesServiceTracingConnection::GetClientConnectorService(
    google::cloud::beyondcorp::clientconnectorservices::v1::
        GetClientConnectorServiceRequest const& request) {
  auto span = internal::MakeSpan(
      "beyondcorp_clientconnectorservices_v1::"
      "ClientConnectorServicesServiceConnection::GetClientConnectorService");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span, child_->GetClientConnectorService(request));
}

future<StatusOr<google::cloud::beyondcorp::clientconnectorservices::v1::
                    ClientConnectorService>>
ClientConnectorServicesServiceTracingConnection::CreateClientConnectorService(
    google::cloud::beyondcorp::clientconnectorservices::v1::
        CreateClientConnectorServiceRequest const& request) {
  auto span = internal::MakeSpan(
      "beyondcorp_clientconnectorservices_v1::"
      "ClientConnectorServicesServiceConnection::CreateClientConnectorService");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(std::move(span),
                           child_->CreateClientConnectorService(request));
}

future<StatusOr<google::cloud::beyondcorp::clientconnectorservices::v1::
                    ClientConnectorService>>
ClientConnectorServicesServiceTracingConnection::UpdateClientConnectorService(
    google::cloud::beyondcorp::clientconnectorservices::v1::
        UpdateClientConnectorServiceRequest const& request) {
  auto span = internal::MakeSpan(
      "beyondcorp_clientconnectorservices_v1::"
      "ClientConnectorServicesServiceConnection::UpdateClientConnectorService");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(std::move(span),
                           child_->UpdateClientConnectorService(request));
}

future<StatusOr<google::cloud::beyondcorp::clientconnectorservices::v1::
                    ClientConnectorServiceOperationMetadata>>
ClientConnectorServicesServiceTracingConnection::DeleteClientConnectorService(
    google::cloud::beyondcorp::clientconnectorservices::v1::
        DeleteClientConnectorServiceRequest const& request) {
  auto span = internal::MakeSpan(
      "beyondcorp_clientconnectorservices_v1::"
      "ClientConnectorServicesServiceConnection::DeleteClientConnectorService");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(std::move(span),
                           child_->DeleteClientConnectorService(request));
}

#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

std::shared_ptr<beyondcorp_clientconnectorservices_v1::
                    ClientConnectorServicesServiceConnection>
MakeClientConnectorServicesServiceTracingConnection(
    std::shared_ptr<beyondcorp_clientconnectorservices_v1::
                        ClientConnectorServicesServiceConnection>
        conn) {
#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  if (internal::TracingEnabled(conn->options())) {
    conn = std::make_shared<ClientConnectorServicesServiceTracingConnection>(
        std::move(conn));
  }
#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  return conn;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace beyondcorp_clientconnectorservices_v1_internal
}  // namespace cloud
}  // namespace google
