// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source:
// google/cloud/beyondcorp/clientgateways/v1/client_gateways_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_BEYONDCORP_CLIENTGATEWAYS_V1_INTERNAL_CLIENT_GATEWAYS_TRACING_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_BEYONDCORP_CLIENTGATEWAYS_V1_INTERNAL_CLIENT_GATEWAYS_TRACING_CONNECTION_H

#include "google/cloud/beyondcorp/clientgateways/v1/client_gateways_connection.h"
#include "google/cloud/version.h"
#include <memory>

namespace google {
namespace cloud {
namespace beyondcorp_clientgateways_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

class ClientGatewaysServiceTracingConnection
    : public beyondcorp_clientgateways_v1::ClientGatewaysServiceConnection {
 public:
  ~ClientGatewaysServiceTracingConnection() override = default;

  explicit ClientGatewaysServiceTracingConnection(
      std::shared_ptr<
          beyondcorp_clientgateways_v1::ClientGatewaysServiceConnection>
          child);

  Options options() override { return child_->options(); }

  StreamRange<google::cloud::beyondcorp::clientgateways::v1::ClientGateway>
  ListClientGateways(
      google::cloud::beyondcorp::clientgateways::v1::ListClientGatewaysRequest
          request) override;

  StatusOr<google::cloud::beyondcorp::clientgateways::v1::ClientGateway>
  GetClientGateway(google::cloud::beyondcorp::clientgateways::v1::
                       GetClientGatewayRequest const& request) override;

  future<StatusOr<google::cloud::beyondcorp::clientgateways::v1::ClientGateway>>
  CreateClientGateway(google::cloud::beyondcorp::clientgateways::v1::
                          CreateClientGatewayRequest const& request) override;

  future<StatusOr<google::cloud::beyondcorp::clientgateways::v1::
                      ClientGatewayOperationMetadata>>
  DeleteClientGateway(google::cloud::beyondcorp::clientgateways::v1::
                          DeleteClientGatewayRequest const& request) override;

 private:
  std::shared_ptr<beyondcorp_clientgateways_v1::ClientGatewaysServiceConnection>
      child_;
};

#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

/**
 * Conditionally applies the tracing decorator to the given connection.
 *
 * The connection is only decorated if tracing is enabled (as determined by the
 * connection's options).
 */
std::shared_ptr<beyondcorp_clientgateways_v1::ClientGatewaysServiceConnection>
MakeClientGatewaysServiceTracingConnection(
    std::shared_ptr<
        beyondcorp_clientgateways_v1::ClientGatewaysServiceConnection>
        conn);

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace beyondcorp_clientgateways_v1_internal
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_BEYONDCORP_CLIENTGATEWAYS_V1_INTERNAL_CLIENT_GATEWAYS_TRACING_CONNECTION_H
