// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/accelerator_types/v1/accelerator_types.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_ACCELERATOR_TYPES_V1_ACCELERATOR_TYPES_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_ACCELERATOR_TYPES_V1_ACCELERATOR_TYPES_CONNECTION_H

#include "google/cloud/compute/accelerator_types/v1/accelerator_types_connection_idempotency_policy.h"
#include "google/cloud/compute/accelerator_types/v1/internal/accelerator_types_retry_traits.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/experimental_tag.h"
#include "google/cloud/options.h"
#include "google/cloud/status_or.h"
#include "google/cloud/stream_range.h"
#include "google/cloud/version.h"
#include <google/cloud/compute/accelerator_types/v1/accelerator_types.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace compute_accelerator_types_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using AcceleratorTypesRetryPolicy =
    ::google::cloud::internal::TraitBasedRetryPolicy<
        compute_accelerator_types_v1_internal::AcceleratorTypesRetryTraits>;

using AcceleratorTypesLimitedTimeRetryPolicy =
    ::google::cloud::internal::LimitedTimeRetryPolicy<
        compute_accelerator_types_v1_internal::AcceleratorTypesRetryTraits>;

using AcceleratorTypesLimitedErrorCountRetryPolicy =
    ::google::cloud::internal::LimitedErrorCountRetryPolicy<
        compute_accelerator_types_v1_internal::AcceleratorTypesRetryTraits>;

/**
 * The `AcceleratorTypesConnection` object for `AcceleratorTypesClient`.
 *
 * This interface defines virtual methods for each of the user-facing overload
 * sets in `AcceleratorTypesClient`. This allows users to inject custom behavior
 * (e.g., with a Google Mock object) when writing tests that use objects of type
 * `AcceleratorTypesClient`.
 *
 * To create a concrete instance, see `MakeAcceleratorTypesConnection()`.
 *
 * For mocking, see
 * `compute_accelerator_types_v1_mocks::MockAcceleratorTypesConnection`.
 */
class AcceleratorTypesConnection {
 public:
  virtual ~AcceleratorTypesConnection() = 0;

  virtual Options options() { return Options{}; }

  virtual StatusOr<
      google::cloud::cpp::compute::v1::AcceleratorTypeAggregatedList>
  AggregatedListAcceleratorTypes(
      google::cloud::cpp::compute::accelerator_types::v1::
          AggregatedListAcceleratorTypesRequest const& request);

  virtual StatusOr<google::cloud::cpp::compute::v1::AcceleratorType>
  GetAcceleratorTypes(google::cloud::cpp::compute::accelerator_types::v1::
                          GetAcceleratorTypesRequest const& request);

  virtual StreamRange<google::cloud::cpp::compute::v1::AcceleratorType>
  ListAcceleratorTypes(google::cloud::cpp::compute::accelerator_types::v1::
                           ListAcceleratorTypesRequest request);
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_accelerator_types_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_ACCELERATOR_TYPES_V1_ACCELERATOR_TYPES_CONNECTION_H
