// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/addresses/v1/addresses.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_ADDRESSES_V1_ADDRESSES_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_ADDRESSES_V1_ADDRESSES_CONNECTION_H

#include "google/cloud/compute/addresses/v1/addresses_connection_idempotency_policy.h"
#include "google/cloud/compute/addresses/v1/internal/addresses_retry_traits.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/experimental_tag.h"
#include "google/cloud/future.h"
#include "google/cloud/options.h"
#include "google/cloud/polling_policy.h"
#include "google/cloud/status_or.h"
#include "google/cloud/stream_range.h"
#include "google/cloud/version.h"
#include <google/cloud/compute/addresses/v1/addresses.pb.h>
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace compute_addresses_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using AddressesRetryPolicy = ::google::cloud::internal::TraitBasedRetryPolicy<
    compute_addresses_v1_internal::AddressesRetryTraits>;

using AddressesLimitedTimeRetryPolicy =
    ::google::cloud::internal::LimitedTimeRetryPolicy<
        compute_addresses_v1_internal::AddressesRetryTraits>;

using AddressesLimitedErrorCountRetryPolicy =
    ::google::cloud::internal::LimitedErrorCountRetryPolicy<
        compute_addresses_v1_internal::AddressesRetryTraits>;

/**
 * The `AddressesConnection` object for `AddressesClient`.
 *
 * This interface defines virtual methods for each of the user-facing overload
 * sets in `AddressesClient`. This allows users to inject custom behavior
 * (e.g., with a Google Mock object) when writing tests that use objects of type
 * `AddressesClient`.
 *
 * To create a concrete instance, see `MakeAddressesConnection()`.
 *
 * For mocking, see `compute_addresses_v1_mocks::MockAddressesConnection`.
 */
class AddressesConnection {
 public:
  virtual ~AddressesConnection() = 0;

  virtual Options options() { return Options{}; }

  virtual StatusOr<google::cloud::cpp::compute::v1::AddressAggregatedList>
  AggregatedListAddresses(google::cloud::cpp::compute::addresses::v1::
                              AggregatedListAddressesRequest const& request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  DeleteAddresses(
      google::cloud::cpp::compute::addresses::v1::DeleteAddressesRequest const&
          request);

  virtual StatusOr<google::cloud::cpp::compute::v1::Address> GetAddresses(
      google::cloud::cpp::compute::addresses::v1::GetAddressesRequest const&
          request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  InsertAddresses(
      google::cloud::cpp::compute::addresses::v1::InsertAddressesRequest const&
          request);

  virtual StreamRange<google::cloud::cpp::compute::v1::Address> ListAddresses(
      google::cloud::cpp::compute::addresses::v1::ListAddressesRequest request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  SetLabels(google::cloud::cpp::compute::addresses::v1::SetLabelsRequest const&
                request);
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_addresses_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_ADDRESSES_V1_ADDRESSES_CONNECTION_H
