// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/autoscalers/v1/autoscalers.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_AUTOSCALERS_V1_AUTOSCALERS_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_AUTOSCALERS_V1_AUTOSCALERS_CONNECTION_H

#include "google/cloud/compute/autoscalers/v1/autoscalers_connection_idempotency_policy.h"
#include "google/cloud/compute/autoscalers/v1/internal/autoscalers_retry_traits.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/experimental_tag.h"
#include "google/cloud/future.h"
#include "google/cloud/options.h"
#include "google/cloud/polling_policy.h"
#include "google/cloud/status_or.h"
#include "google/cloud/stream_range.h"
#include "google/cloud/version.h"
#include <google/cloud/compute/autoscalers/v1/autoscalers.pb.h>
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace compute_autoscalers_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using AutoscalersRetryPolicy = ::google::cloud::internal::TraitBasedRetryPolicy<
    compute_autoscalers_v1_internal::AutoscalersRetryTraits>;

using AutoscalersLimitedTimeRetryPolicy =
    ::google::cloud::internal::LimitedTimeRetryPolicy<
        compute_autoscalers_v1_internal::AutoscalersRetryTraits>;

using AutoscalersLimitedErrorCountRetryPolicy =
    ::google::cloud::internal::LimitedErrorCountRetryPolicy<
        compute_autoscalers_v1_internal::AutoscalersRetryTraits>;

/**
 * The `AutoscalersConnection` object for `AutoscalersClient`.
 *
 * This interface defines virtual methods for each of the user-facing overload
 * sets in `AutoscalersClient`. This allows users to inject custom behavior
 * (e.g., with a Google Mock object) when writing tests that use objects of type
 * `AutoscalersClient`.
 *
 * To create a concrete instance, see `MakeAutoscalersConnection()`.
 *
 * For mocking, see `compute_autoscalers_v1_mocks::MockAutoscalersConnection`.
 */
class AutoscalersConnection {
 public:
  virtual ~AutoscalersConnection() = 0;

  virtual Options options() { return Options{}; }

  virtual StatusOr<google::cloud::cpp::compute::v1::AutoscalerAggregatedList>
  AggregatedListAutoscalers(
      google::cloud::cpp::compute::autoscalers::v1::
          AggregatedListAutoscalersRequest const& request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  DeleteAutoscalers(google::cloud::cpp::compute::autoscalers::v1::
                        DeleteAutoscalersRequest const& request);

  virtual StatusOr<google::cloud::cpp::compute::v1::Autoscaler> GetAutoscalers(
      google::cloud::cpp::compute::autoscalers::v1::GetAutoscalersRequest const&
          request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  InsertAutoscalers(google::cloud::cpp::compute::autoscalers::v1::
                        InsertAutoscalersRequest const& request);

  virtual StreamRange<google::cloud::cpp::compute::v1::Autoscaler>
  ListAutoscalers(
      google::cloud::cpp::compute::autoscalers::v1::ListAutoscalersRequest
          request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  PatchAutoscalers(google::cloud::cpp::compute::autoscalers::v1::
                       PatchAutoscalersRequest const& request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  UpdateAutoscalers(google::cloud::cpp::compute::autoscalers::v1::
                        UpdateAutoscalersRequest const& request);
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_autoscalers_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_AUTOSCALERS_V1_AUTOSCALERS_CONNECTION_H
