// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/health_checks/v1/health_checks.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_HEALTH_CHECKS_V1_HEALTH_CHECKS_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_HEALTH_CHECKS_V1_HEALTH_CHECKS_CONNECTION_H

#include "google/cloud/compute/health_checks/v1/health_checks_connection_idempotency_policy.h"
#include "google/cloud/compute/health_checks/v1/internal/health_checks_retry_traits.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/experimental_tag.h"
#include "google/cloud/future.h"
#include "google/cloud/options.h"
#include "google/cloud/polling_policy.h"
#include "google/cloud/status_or.h"
#include "google/cloud/stream_range.h"
#include "google/cloud/version.h"
#include <google/cloud/compute/health_checks/v1/health_checks.pb.h>
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace compute_health_checks_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using HealthChecksRetryPolicy =
    ::google::cloud::internal::TraitBasedRetryPolicy<
        compute_health_checks_v1_internal::HealthChecksRetryTraits>;

using HealthChecksLimitedTimeRetryPolicy =
    ::google::cloud::internal::LimitedTimeRetryPolicy<
        compute_health_checks_v1_internal::HealthChecksRetryTraits>;

using HealthChecksLimitedErrorCountRetryPolicy =
    ::google::cloud::internal::LimitedErrorCountRetryPolicy<
        compute_health_checks_v1_internal::HealthChecksRetryTraits>;

/**
 * The `HealthChecksConnection` object for `HealthChecksClient`.
 *
 * This interface defines virtual methods for each of the user-facing overload
 * sets in `HealthChecksClient`. This allows users to inject custom behavior
 * (e.g., with a Google Mock object) when writing tests that use objects of type
 * `HealthChecksClient`.
 *
 * To create a concrete instance, see `MakeHealthChecksConnection()`.
 *
 * For mocking, see
 * `compute_health_checks_v1_mocks::MockHealthChecksConnection`.
 */
class HealthChecksConnection {
 public:
  virtual ~HealthChecksConnection() = 0;

  virtual Options options() { return Options{}; }

  virtual StatusOr<google::cloud::cpp::compute::v1::HealthChecksAggregatedList>
  AggregatedListHealthChecks(
      google::cloud::cpp::compute::health_checks::v1::
          AggregatedListHealthChecksRequest const& request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  DeleteHealthChecks(google::cloud::cpp::compute::health_checks::v1::
                         DeleteHealthChecksRequest const& request);

  virtual StatusOr<google::cloud::cpp::compute::v1::HealthCheck>
  GetHealthChecks(google::cloud::cpp::compute::health_checks::v1::
                      GetHealthChecksRequest const& request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  InsertHealthChecks(google::cloud::cpp::compute::health_checks::v1::
                         InsertHealthChecksRequest const& request);

  virtual StreamRange<google::cloud::cpp::compute::v1::HealthCheck>
  ListHealthChecks(
      google::cloud::cpp::compute::health_checks::v1::ListHealthChecksRequest
          request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  PatchHealthChecks(google::cloud::cpp::compute::health_checks::v1::
                        PatchHealthChecksRequest const& request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  UpdateHealthChecks(google::cloud::cpp::compute::health_checks::v1::
                         UpdateHealthChecksRequest const& request);
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_health_checks_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_HEALTH_CHECKS_V1_HEALTH_CHECKS_CONNECTION_H
