// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/https_health_checks/v1/https_health_checks.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_HTTPS_HEALTH_CHECKS_V1_HTTPS_HEALTH_CHECKS_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_HTTPS_HEALTH_CHECKS_V1_HTTPS_HEALTH_CHECKS_CONNECTION_H

#include "google/cloud/compute/https_health_checks/v1/https_health_checks_connection_idempotency_policy.h"
#include "google/cloud/compute/https_health_checks/v1/internal/https_health_checks_retry_traits.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/experimental_tag.h"
#include "google/cloud/future.h"
#include "google/cloud/options.h"
#include "google/cloud/polling_policy.h"
#include "google/cloud/status_or.h"
#include "google/cloud/stream_range.h"
#include "google/cloud/version.h"
#include <google/cloud/compute/https_health_checks/v1/https_health_checks.pb.h>
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace compute_https_health_checks_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using HttpsHealthChecksRetryPolicy =
    ::google::cloud::internal::TraitBasedRetryPolicy<
        compute_https_health_checks_v1_internal::HttpsHealthChecksRetryTraits>;

using HttpsHealthChecksLimitedTimeRetryPolicy =
    ::google::cloud::internal::LimitedTimeRetryPolicy<
        compute_https_health_checks_v1_internal::HttpsHealthChecksRetryTraits>;

using HttpsHealthChecksLimitedErrorCountRetryPolicy =
    ::google::cloud::internal::LimitedErrorCountRetryPolicy<
        compute_https_health_checks_v1_internal::HttpsHealthChecksRetryTraits>;

/**
 * The `HttpsHealthChecksConnection` object for `HttpsHealthChecksClient`.
 *
 * This interface defines virtual methods for each of the user-facing overload
 * sets in `HttpsHealthChecksClient`. This allows users to inject custom
 * behavior (e.g., with a Google Mock object) when writing tests that use
 * objects of type `HttpsHealthChecksClient`.
 *
 * To create a concrete instance, see `MakeHttpsHealthChecksConnection()`.
 *
 * For mocking, see
 * `compute_https_health_checks_v1_mocks::MockHttpsHealthChecksConnection`.
 */
class HttpsHealthChecksConnection {
 public:
  virtual ~HttpsHealthChecksConnection() = 0;

  virtual Options options() { return Options{}; }

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  DeleteHttpsHealthChecks(google::cloud::cpp::compute::https_health_checks::v1::
                              DeleteHttpsHealthChecksRequest const& request);

  virtual StatusOr<google::cloud::cpp::compute::v1::HttpsHealthCheck>
  GetHttpsHealthChecks(google::cloud::cpp::compute::https_health_checks::v1::
                           GetHttpsHealthChecksRequest const& request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  InsertHttpsHealthChecks(google::cloud::cpp::compute::https_health_checks::v1::
                              InsertHttpsHealthChecksRequest const& request);

  virtual StreamRange<google::cloud::cpp::compute::v1::HttpsHealthCheck>
  ListHttpsHealthChecks(google::cloud::cpp::compute::https_health_checks::v1::
                            ListHttpsHealthChecksRequest request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  PatchHttpsHealthChecks(google::cloud::cpp::compute::https_health_checks::v1::
                             PatchHttpsHealthChecksRequest const& request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  UpdateHttpsHealthChecks(google::cloud::cpp::compute::https_health_checks::v1::
                              UpdateHttpsHealthChecksRequest const& request);
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_https_health_checks_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_HTTPS_HEALTH_CHECKS_V1_HTTPS_HEALTH_CHECKS_CONNECTION_H
