// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/image_family_views/v1/image_family_views.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_IMAGE_FAMILY_VIEWS_V1_IMAGE_FAMILY_VIEWS_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_IMAGE_FAMILY_VIEWS_V1_IMAGE_FAMILY_VIEWS_CONNECTION_H

#include "google/cloud/compute/image_family_views/v1/image_family_views_connection_idempotency_policy.h"
#include "google/cloud/compute/image_family_views/v1/internal/image_family_views_retry_traits.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/experimental_tag.h"
#include "google/cloud/options.h"
#include "google/cloud/status_or.h"
#include "google/cloud/version.h"
#include <google/cloud/compute/image_family_views/v1/image_family_views.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace compute_image_family_views_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ImageFamilyViewsRetryPolicy =
    ::google::cloud::internal::TraitBasedRetryPolicy<
        compute_image_family_views_v1_internal::ImageFamilyViewsRetryTraits>;

using ImageFamilyViewsLimitedTimeRetryPolicy =
    ::google::cloud::internal::LimitedTimeRetryPolicy<
        compute_image_family_views_v1_internal::ImageFamilyViewsRetryTraits>;

using ImageFamilyViewsLimitedErrorCountRetryPolicy =
    ::google::cloud::internal::LimitedErrorCountRetryPolicy<
        compute_image_family_views_v1_internal::ImageFamilyViewsRetryTraits>;

/**
 * The `ImageFamilyViewsConnection` object for `ImageFamilyViewsClient`.
 *
 * This interface defines virtual methods for each of the user-facing overload
 * sets in `ImageFamilyViewsClient`. This allows users to inject custom behavior
 * (e.g., with a Google Mock object) when writing tests that use objects of type
 * `ImageFamilyViewsClient`.
 *
 * To create a concrete instance, see `MakeImageFamilyViewsConnection()`.
 *
 * For mocking, see
 * `compute_image_family_views_v1_mocks::MockImageFamilyViewsConnection`.
 */
class ImageFamilyViewsConnection {
 public:
  virtual ~ImageFamilyViewsConnection() = 0;

  virtual Options options() { return Options{}; }

  virtual StatusOr<google::cloud::cpp::compute::v1::ImageFamilyView>
  GetImageFamilyViews(google::cloud::cpp::compute::image_family_views::v1::
                          GetImageFamilyViewsRequest const& request);
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_image_family_views_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_IMAGE_FAMILY_VIEWS_V1_IMAGE_FAMILY_VIEWS_CONNECTION_H
