// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/images/v1/images.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_IMAGES_V1_IMAGES_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_IMAGES_V1_IMAGES_CONNECTION_H

#include "google/cloud/compute/images/v1/images_connection_idempotency_policy.h"
#include "google/cloud/compute/images/v1/internal/images_retry_traits.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/experimental_tag.h"
#include "google/cloud/future.h"
#include "google/cloud/options.h"
#include "google/cloud/polling_policy.h"
#include "google/cloud/status_or.h"
#include "google/cloud/stream_range.h"
#include "google/cloud/version.h"
#include <google/cloud/compute/images/v1/images.pb.h>
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace compute_images_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ImagesRetryPolicy = ::google::cloud::internal::TraitBasedRetryPolicy<
    compute_images_v1_internal::ImagesRetryTraits>;

using ImagesLimitedTimeRetryPolicy =
    ::google::cloud::internal::LimitedTimeRetryPolicy<
        compute_images_v1_internal::ImagesRetryTraits>;

using ImagesLimitedErrorCountRetryPolicy =
    ::google::cloud::internal::LimitedErrorCountRetryPolicy<
        compute_images_v1_internal::ImagesRetryTraits>;

/**
 * The `ImagesConnection` object for `ImagesClient`.
 *
 * This interface defines virtual methods for each of the user-facing overload
 * sets in `ImagesClient`. This allows users to inject custom behavior
 * (e.g., with a Google Mock object) when writing tests that use objects of type
 * `ImagesClient`.
 *
 * To create a concrete instance, see `MakeImagesConnection()`.
 *
 * For mocking, see `compute_images_v1_mocks::MockImagesConnection`.
 */
class ImagesConnection {
 public:
  virtual ~ImagesConnection() = 0;

  virtual Options options() { return Options{}; }

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  DeleteImages(
      google::cloud::cpp::compute::images::v1::DeleteImagesRequest const&
          request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  Deprecate(
      google::cloud::cpp::compute::images::v1::DeprecateRequest const& request);

  virtual StatusOr<google::cloud::cpp::compute::v1::Image> GetImages(
      google::cloud::cpp::compute::images::v1::GetImagesRequest const& request);

  virtual StatusOr<google::cloud::cpp::compute::v1::Image> GetFromFamily(
      google::cloud::cpp::compute::images::v1::GetFromFamilyRequest const&
          request);

  virtual StatusOr<google::cloud::cpp::compute::v1::Policy> GetIamPolicy(
      google::cloud::cpp::compute::images::v1::GetIamPolicyRequest const&
          request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  InsertImages(
      google::cloud::cpp::compute::images::v1::InsertImagesRequest const&
          request);

  virtual StreamRange<google::cloud::cpp::compute::v1::Image> ListImages(
      google::cloud::cpp::compute::images::v1::ListImagesRequest request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  PatchImages(google::cloud::cpp::compute::images::v1::PatchImagesRequest const&
                  request);

  virtual StatusOr<google::cloud::cpp::compute::v1::Policy> SetIamPolicy(
      google::cloud::cpp::compute::images::v1::SetIamPolicyRequest const&
          request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  SetLabels(
      google::cloud::cpp::compute::images::v1::SetLabelsRequest const& request);

  virtual StatusOr<google::cloud::cpp::compute::v1::TestPermissionsResponse>
  TestIamPermissions(
      google::cloud::cpp::compute::images::v1::TestIamPermissionsRequest const&
          request);
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_images_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_IMAGES_V1_IMAGES_CONNECTION_H
