// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source:
// google/cloud/compute/interconnect_attachments/v1/interconnect_attachments.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_INTERCONNECT_ATTACHMENTS_V1_INTERCONNECT_ATTACHMENTS_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_INTERCONNECT_ATTACHMENTS_V1_INTERCONNECT_ATTACHMENTS_CONNECTION_H

#include "google/cloud/compute/interconnect_attachments/v1/interconnect_attachments_connection_idempotency_policy.h"
#include "google/cloud/compute/interconnect_attachments/v1/internal/interconnect_attachments_retry_traits.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/experimental_tag.h"
#include "google/cloud/future.h"
#include "google/cloud/options.h"
#include "google/cloud/polling_policy.h"
#include "google/cloud/status_or.h"
#include "google/cloud/stream_range.h"
#include "google/cloud/version.h"
#include <google/cloud/compute/interconnect_attachments/v1/interconnect_attachments.pb.h>
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace compute_interconnect_attachments_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using InterconnectAttachmentsRetryPolicy =
    ::google::cloud::internal::TraitBasedRetryPolicy<
        compute_interconnect_attachments_v1_internal::
            InterconnectAttachmentsRetryTraits>;

using InterconnectAttachmentsLimitedTimeRetryPolicy =
    ::google::cloud::internal::LimitedTimeRetryPolicy<
        compute_interconnect_attachments_v1_internal::
            InterconnectAttachmentsRetryTraits>;

using InterconnectAttachmentsLimitedErrorCountRetryPolicy =
    ::google::cloud::internal::LimitedErrorCountRetryPolicy<
        compute_interconnect_attachments_v1_internal::
            InterconnectAttachmentsRetryTraits>;

/**
 * The `InterconnectAttachmentsConnection` object for
 * `InterconnectAttachmentsClient`.
 *
 * This interface defines virtual methods for each of the user-facing overload
 * sets in `InterconnectAttachmentsClient`. This allows users to inject custom
 * behavior (e.g., with a Google Mock object) when writing tests that use
 * objects of type `InterconnectAttachmentsClient`.
 *
 * To create a concrete instance, see `MakeInterconnectAttachmentsConnection()`.
 *
 * For mocking, see
 * `compute_interconnect_attachments_v1_mocks::MockInterconnectAttachmentsConnection`.
 */
class InterconnectAttachmentsConnection {
 public:
  virtual ~InterconnectAttachmentsConnection() = 0;

  virtual Options options() { return Options{}; }

  virtual StatusOr<
      google::cloud::cpp::compute::v1::InterconnectAttachmentAggregatedList>
  AggregatedListInterconnectAttachments(
      google::cloud::cpp::compute::interconnect_attachments::v1::
          AggregatedListInterconnectAttachmentsRequest const& request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  DeleteInterconnectAttachments(
      google::cloud::cpp::compute::interconnect_attachments::v1::
          DeleteInterconnectAttachmentsRequest const& request);

  virtual StatusOr<google::cloud::cpp::compute::v1::InterconnectAttachment>
  GetInterconnectAttachments(
      google::cloud::cpp::compute::interconnect_attachments::v1::
          GetInterconnectAttachmentsRequest const& request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  InsertInterconnectAttachments(
      google::cloud::cpp::compute::interconnect_attachments::v1::
          InsertInterconnectAttachmentsRequest const& request);

  virtual StreamRange<google::cloud::cpp::compute::v1::InterconnectAttachment>
  ListInterconnectAttachments(
      google::cloud::cpp::compute::interconnect_attachments::v1::
          ListInterconnectAttachmentsRequest request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  PatchInterconnectAttachments(
      google::cloud::cpp::compute::interconnect_attachments::v1::
          PatchInterconnectAttachmentsRequest const& request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  SetLabels(google::cloud::cpp::compute::interconnect_attachments::v1::
                SetLabelsRequest const& request);
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_interconnect_attachments_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_INTERCONNECT_ATTACHMENTS_V1_INTERCONNECT_ATTACHMENTS_CONNECTION_H
