// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source:
// google/cloud/compute/interconnect_locations/v1/interconnect_locations.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_INTERCONNECT_LOCATIONS_V1_INTERCONNECT_LOCATIONS_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_INTERCONNECT_LOCATIONS_V1_INTERCONNECT_LOCATIONS_CONNECTION_H

#include "google/cloud/compute/interconnect_locations/v1/interconnect_locations_connection_idempotency_policy.h"
#include "google/cloud/compute/interconnect_locations/v1/internal/interconnect_locations_retry_traits.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/experimental_tag.h"
#include "google/cloud/options.h"
#include "google/cloud/status_or.h"
#include "google/cloud/stream_range.h"
#include "google/cloud/version.h"
#include <google/cloud/compute/interconnect_locations/v1/interconnect_locations.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace compute_interconnect_locations_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using InterconnectLocationsRetryPolicy =
    ::google::cloud::internal::TraitBasedRetryPolicy<
        compute_interconnect_locations_v1_internal::
            InterconnectLocationsRetryTraits>;

using InterconnectLocationsLimitedTimeRetryPolicy =
    ::google::cloud::internal::LimitedTimeRetryPolicy<
        compute_interconnect_locations_v1_internal::
            InterconnectLocationsRetryTraits>;

using InterconnectLocationsLimitedErrorCountRetryPolicy =
    ::google::cloud::internal::LimitedErrorCountRetryPolicy<
        compute_interconnect_locations_v1_internal::
            InterconnectLocationsRetryTraits>;

/**
 * The `InterconnectLocationsConnection` object for
 * `InterconnectLocationsClient`.
 *
 * This interface defines virtual methods for each of the user-facing overload
 * sets in `InterconnectLocationsClient`. This allows users to inject custom
 * behavior (e.g., with a Google Mock object) when writing tests that use
 * objects of type `InterconnectLocationsClient`.
 *
 * To create a concrete instance, see `MakeInterconnectLocationsConnection()`.
 *
 * For mocking, see
 * `compute_interconnect_locations_v1_mocks::MockInterconnectLocationsConnection`.
 */
class InterconnectLocationsConnection {
 public:
  virtual ~InterconnectLocationsConnection() = 0;

  virtual Options options() { return Options{}; }

  virtual StatusOr<google::cloud::cpp::compute::v1::InterconnectLocation>
  GetInterconnectLocations(
      google::cloud::cpp::compute::interconnect_locations::v1::
          GetInterconnectLocationsRequest const& request);

  virtual StreamRange<google::cloud::cpp::compute::v1::InterconnectLocation>
  ListInterconnectLocations(
      google::cloud::cpp::compute::interconnect_locations::v1::
          ListInterconnectLocationsRequest request);
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_interconnect_locations_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_INTERCONNECT_LOCATIONS_V1_INTERCONNECT_LOCATIONS_CONNECTION_H
