// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/interconnects/v1/interconnects.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_INTERCONNECTS_V1_INTERCONNECTS_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_INTERCONNECTS_V1_INTERCONNECTS_CONNECTION_H

#include "google/cloud/compute/interconnects/v1/interconnects_connection_idempotency_policy.h"
#include "google/cloud/compute/interconnects/v1/internal/interconnects_retry_traits.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/experimental_tag.h"
#include "google/cloud/future.h"
#include "google/cloud/options.h"
#include "google/cloud/polling_policy.h"
#include "google/cloud/status_or.h"
#include "google/cloud/stream_range.h"
#include "google/cloud/version.h"
#include <google/cloud/compute/interconnects/v1/interconnects.pb.h>
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace compute_interconnects_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using InterconnectsRetryPolicy =
    ::google::cloud::internal::TraitBasedRetryPolicy<
        compute_interconnects_v1_internal::InterconnectsRetryTraits>;

using InterconnectsLimitedTimeRetryPolicy =
    ::google::cloud::internal::LimitedTimeRetryPolicy<
        compute_interconnects_v1_internal::InterconnectsRetryTraits>;

using InterconnectsLimitedErrorCountRetryPolicy =
    ::google::cloud::internal::LimitedErrorCountRetryPolicy<
        compute_interconnects_v1_internal::InterconnectsRetryTraits>;

/**
 * The `InterconnectsConnection` object for `InterconnectsClient`.
 *
 * This interface defines virtual methods for each of the user-facing overload
 * sets in `InterconnectsClient`. This allows users to inject custom behavior
 * (e.g., with a Google Mock object) when writing tests that use objects of type
 * `InterconnectsClient`.
 *
 * To create a concrete instance, see `MakeInterconnectsConnection()`.
 *
 * For mocking, see
 * `compute_interconnects_v1_mocks::MockInterconnectsConnection`.
 */
class InterconnectsConnection {
 public:
  virtual ~InterconnectsConnection() = 0;

  virtual Options options() { return Options{}; }

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  DeleteInterconnects(google::cloud::cpp::compute::interconnects::v1::
                          DeleteInterconnectsRequest const& request);

  virtual StatusOr<google::cloud::cpp::compute::v1::Interconnect>
  GetInterconnects(google::cloud::cpp::compute::interconnects::v1::
                       GetInterconnectsRequest const& request);

  virtual StatusOr<
      google::cloud::cpp::compute::v1::InterconnectsGetDiagnosticsResponse>
  GetDiagnostics(google::cloud::cpp::compute::interconnects::v1::
                     GetDiagnosticsRequest const& request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  InsertInterconnects(google::cloud::cpp::compute::interconnects::v1::
                          InsertInterconnectsRequest const& request);

  virtual StreamRange<google::cloud::cpp::compute::v1::Interconnect>
  ListInterconnects(
      google::cloud::cpp::compute::interconnects::v1::ListInterconnectsRequest
          request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  PatchInterconnects(google::cloud::cpp::compute::interconnects::v1::
                         PatchInterconnectsRequest const& request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  SetLabels(
      google::cloud::cpp::compute::interconnects::v1::SetLabelsRequest const&
          request);
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_interconnects_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_INTERCONNECTS_V1_INTERCONNECTS_CONNECTION_H
