// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/license_codes/v1/license_codes.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_LICENSE_CODES_V1_LICENSE_CODES_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_LICENSE_CODES_V1_LICENSE_CODES_CONNECTION_H

#include "google/cloud/compute/license_codes/v1/internal/license_codes_retry_traits.h"
#include "google/cloud/compute/license_codes/v1/license_codes_connection_idempotency_policy.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/experimental_tag.h"
#include "google/cloud/options.h"
#include "google/cloud/status_or.h"
#include "google/cloud/version.h"
#include <google/cloud/compute/license_codes/v1/license_codes.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace compute_license_codes_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using LicenseCodesRetryPolicy =
    ::google::cloud::internal::TraitBasedRetryPolicy<
        compute_license_codes_v1_internal::LicenseCodesRetryTraits>;

using LicenseCodesLimitedTimeRetryPolicy =
    ::google::cloud::internal::LimitedTimeRetryPolicy<
        compute_license_codes_v1_internal::LicenseCodesRetryTraits>;

using LicenseCodesLimitedErrorCountRetryPolicy =
    ::google::cloud::internal::LimitedErrorCountRetryPolicy<
        compute_license_codes_v1_internal::LicenseCodesRetryTraits>;

/**
 * The `LicenseCodesConnection` object for `LicenseCodesClient`.
 *
 * This interface defines virtual methods for each of the user-facing overload
 * sets in `LicenseCodesClient`. This allows users to inject custom behavior
 * (e.g., with a Google Mock object) when writing tests that use objects of type
 * `LicenseCodesClient`.
 *
 * To create a concrete instance, see `MakeLicenseCodesConnection()`.
 *
 * For mocking, see
 * `compute_license_codes_v1_mocks::MockLicenseCodesConnection`.
 */
class LicenseCodesConnection {
 public:
  virtual ~LicenseCodesConnection() = 0;

  virtual Options options() { return Options{}; }

  virtual StatusOr<google::cloud::cpp::compute::v1::LicenseCode>
  GetLicenseCodes(google::cloud::cpp::compute::license_codes::v1::
                      GetLicenseCodesRequest const& request);

  virtual StatusOr<google::cloud::cpp::compute::v1::TestPermissionsResponse>
  TestIamPermissions(google::cloud::cpp::compute::license_codes::v1::
                         TestIamPermissionsRequest const& request);
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_license_codes_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_LICENSE_CODES_V1_LICENSE_CODES_CONNECTION_H
