// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/node_types/v1/node_types.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_NODE_TYPES_V1_NODE_TYPES_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_NODE_TYPES_V1_NODE_TYPES_CONNECTION_H

#include "google/cloud/compute/node_types/v1/internal/node_types_retry_traits.h"
#include "google/cloud/compute/node_types/v1/node_types_connection_idempotency_policy.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/experimental_tag.h"
#include "google/cloud/options.h"
#include "google/cloud/status_or.h"
#include "google/cloud/stream_range.h"
#include "google/cloud/version.h"
#include <google/cloud/compute/node_types/v1/node_types.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace compute_node_types_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using NodeTypesRetryPolicy = ::google::cloud::internal::TraitBasedRetryPolicy<
    compute_node_types_v1_internal::NodeTypesRetryTraits>;

using NodeTypesLimitedTimeRetryPolicy =
    ::google::cloud::internal::LimitedTimeRetryPolicy<
        compute_node_types_v1_internal::NodeTypesRetryTraits>;

using NodeTypesLimitedErrorCountRetryPolicy =
    ::google::cloud::internal::LimitedErrorCountRetryPolicy<
        compute_node_types_v1_internal::NodeTypesRetryTraits>;

/**
 * The `NodeTypesConnection` object for `NodeTypesClient`.
 *
 * This interface defines virtual methods for each of the user-facing overload
 * sets in `NodeTypesClient`. This allows users to inject custom behavior
 * (e.g., with a Google Mock object) when writing tests that use objects of type
 * `NodeTypesClient`.
 *
 * To create a concrete instance, see `MakeNodeTypesConnection()`.
 *
 * For mocking, see `compute_node_types_v1_mocks::MockNodeTypesConnection`.
 */
class NodeTypesConnection {
 public:
  virtual ~NodeTypesConnection() = 0;

  virtual Options options() { return Options{}; }

  virtual StatusOr<google::cloud::cpp::compute::v1::NodeTypeAggregatedList>
  AggregatedListNodeTypes(google::cloud::cpp::compute::node_types::v1::
                              AggregatedListNodeTypesRequest const& request);

  virtual StatusOr<google::cloud::cpp::compute::v1::NodeType> GetNodeTypes(
      google::cloud::cpp::compute::node_types::v1::GetNodeTypesRequest const&
          request);

  virtual StreamRange<google::cloud::cpp::compute::v1::NodeType> ListNodeTypes(
      google::cloud::cpp::compute::node_types::v1::ListNodeTypesRequest
          request);
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_node_types_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_NODE_TYPES_V1_NODE_TYPES_CONNECTION_H
