// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source:
// google/cloud/compute/region_instance_groups/v1/region_instance_groups.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_REGION_INSTANCE_GROUPS_V1_REGION_INSTANCE_GROUPS_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_REGION_INSTANCE_GROUPS_V1_REGION_INSTANCE_GROUPS_CONNECTION_H

#include "google/cloud/compute/region_instance_groups/v1/internal/region_instance_groups_retry_traits.h"
#include "google/cloud/compute/region_instance_groups/v1/region_instance_groups_connection_idempotency_policy.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/experimental_tag.h"
#include "google/cloud/future.h"
#include "google/cloud/options.h"
#include "google/cloud/polling_policy.h"
#include "google/cloud/status_or.h"
#include "google/cloud/stream_range.h"
#include "google/cloud/version.h"
#include <google/cloud/compute/region_instance_groups/v1/region_instance_groups.pb.h>
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace compute_region_instance_groups_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using RegionInstanceGroupsRetryPolicy =
    ::google::cloud::internal::TraitBasedRetryPolicy<
        compute_region_instance_groups_v1_internal::
            RegionInstanceGroupsRetryTraits>;

using RegionInstanceGroupsLimitedTimeRetryPolicy =
    ::google::cloud::internal::LimitedTimeRetryPolicy<
        compute_region_instance_groups_v1_internal::
            RegionInstanceGroupsRetryTraits>;

using RegionInstanceGroupsLimitedErrorCountRetryPolicy =
    ::google::cloud::internal::LimitedErrorCountRetryPolicy<
        compute_region_instance_groups_v1_internal::
            RegionInstanceGroupsRetryTraits>;

/**
 * The `RegionInstanceGroupsConnection` object for `RegionInstanceGroupsClient`.
 *
 * This interface defines virtual methods for each of the user-facing overload
 * sets in `RegionInstanceGroupsClient`. This allows users to inject custom
 * behavior (e.g., with a Google Mock object) when writing tests that use
 * objects of type `RegionInstanceGroupsClient`.
 *
 * To create a concrete instance, see `MakeRegionInstanceGroupsConnection()`.
 *
 * For mocking, see
 * `compute_region_instance_groups_v1_mocks::MockRegionInstanceGroupsConnection`.
 */
class RegionInstanceGroupsConnection {
 public:
  virtual ~RegionInstanceGroupsConnection() = 0;

  virtual Options options() { return Options{}; }

  virtual StatusOr<google::cloud::cpp::compute::v1::InstanceGroup>
  GetRegionInstanceGroups(
      google::cloud::cpp::compute::region_instance_groups::v1::
          GetRegionInstanceGroupsRequest const& request);

  virtual StreamRange<google::cloud::cpp::compute::v1::InstanceGroup>
  ListRegionInstanceGroups(google::cloud::cpp::compute::region_instance_groups::
                               v1::ListRegionInstanceGroupsRequest request);

  virtual StreamRange<google::cloud::cpp::compute::v1::InstanceWithNamedPorts>
  ListInstances(google::cloud::cpp::compute::region_instance_groups::v1::
                    ListInstancesRequest request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  SetNamedPorts(google::cloud::cpp::compute::region_instance_groups::v1::
                    SetNamedPortsRequest const& request);
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_region_instance_groups_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_REGION_INSTANCE_GROUPS_V1_REGION_INSTANCE_GROUPS_CONNECTION_H
