// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source:
// google/cloud/compute/region_network_firewall_policies/v1/region_network_firewall_policies.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_REGION_NETWORK_FIREWALL_POLICIES_V1_REGION_NETWORK_FIREWALL_POLICIES_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_REGION_NETWORK_FIREWALL_POLICIES_V1_REGION_NETWORK_FIREWALL_POLICIES_CONNECTION_H

#include "google/cloud/compute/region_network_firewall_policies/v1/internal/region_network_firewall_policies_retry_traits.h"
#include "google/cloud/compute/region_network_firewall_policies/v1/region_network_firewall_policies_connection_idempotency_policy.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/experimental_tag.h"
#include "google/cloud/future.h"
#include "google/cloud/options.h"
#include "google/cloud/polling_policy.h"
#include "google/cloud/status_or.h"
#include "google/cloud/stream_range.h"
#include "google/cloud/version.h"
#include <google/cloud/compute/region_network_firewall_policies/v1/region_network_firewall_policies.pb.h>
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace compute_region_network_firewall_policies_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using RegionNetworkFirewallPoliciesRetryPolicy =
    ::google::cloud::internal::TraitBasedRetryPolicy<
        compute_region_network_firewall_policies_v1_internal::
            RegionNetworkFirewallPoliciesRetryTraits>;

using RegionNetworkFirewallPoliciesLimitedTimeRetryPolicy =
    ::google::cloud::internal::LimitedTimeRetryPolicy<
        compute_region_network_firewall_policies_v1_internal::
            RegionNetworkFirewallPoliciesRetryTraits>;

using RegionNetworkFirewallPoliciesLimitedErrorCountRetryPolicy =
    ::google::cloud::internal::LimitedErrorCountRetryPolicy<
        compute_region_network_firewall_policies_v1_internal::
            RegionNetworkFirewallPoliciesRetryTraits>;

/**
 * The `RegionNetworkFirewallPoliciesConnection` object for
 * `RegionNetworkFirewallPoliciesClient`.
 *
 * This interface defines virtual methods for each of the user-facing overload
 * sets in `RegionNetworkFirewallPoliciesClient`. This allows users to inject
 * custom behavior (e.g., with a Google Mock object) when writing tests that use
 * objects of type `RegionNetworkFirewallPoliciesClient`.
 *
 * To create a concrete instance, see
 * `MakeRegionNetworkFirewallPoliciesConnection()`.
 *
 * For mocking, see
 * `compute_region_network_firewall_policies_v1_mocks::MockRegionNetworkFirewallPoliciesConnection`.
 */
class RegionNetworkFirewallPoliciesConnection {
 public:
  virtual ~RegionNetworkFirewallPoliciesConnection() = 0;

  virtual Options options() { return Options{}; }

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  AddAssociation(google::cloud::cpp::compute::region_network_firewall_policies::
                     v1::AddAssociationRequest const& request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>> AddRule(
      google::cloud::cpp::compute::region_network_firewall_policies::v1::
          AddRuleRequest const& request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  CloneRules(google::cloud::cpp::compute::region_network_firewall_policies::v1::
                 CloneRulesRequest const& request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  DeleteRegionNetworkFirewallPolicies(
      google::cloud::cpp::compute::region_network_firewall_policies::v1::
          DeleteRegionNetworkFirewallPoliciesRequest const& request);

  virtual StatusOr<google::cloud::cpp::compute::v1::FirewallPolicy>
  GetRegionNetworkFirewallPolicies(
      google::cloud::cpp::compute::region_network_firewall_policies::v1::
          GetRegionNetworkFirewallPoliciesRequest const& request);

  virtual StatusOr<google::cloud::cpp::compute::v1::FirewallPolicyAssociation>
  GetAssociation(google::cloud::cpp::compute::region_network_firewall_policies::
                     v1::GetAssociationRequest const& request);

  virtual StatusOr<
      google::cloud::cpp::compute::v1::
          RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse>
  GetEffectiveFirewalls(
      google::cloud::cpp::compute::region_network_firewall_policies::v1::
          GetEffectiveFirewallsRequest const& request);

  virtual StatusOr<google::cloud::cpp::compute::v1::Policy> GetIamPolicy(
      google::cloud::cpp::compute::region_network_firewall_policies::v1::
          GetIamPolicyRequest const& request);

  virtual StatusOr<google::cloud::cpp::compute::v1::FirewallPolicyRule> GetRule(
      google::cloud::cpp::compute::region_network_firewall_policies::v1::
          GetRuleRequest const& request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  InsertRegionNetworkFirewallPolicies(
      google::cloud::cpp::compute::region_network_firewall_policies::v1::
          InsertRegionNetworkFirewallPoliciesRequest const& request);

  virtual StreamRange<google::cloud::cpp::compute::v1::FirewallPolicy>
  ListRegionNetworkFirewallPolicies(
      google::cloud::cpp::compute::region_network_firewall_policies::v1::
          ListRegionNetworkFirewallPoliciesRequest request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  PatchRegionNetworkFirewallPolicies(
      google::cloud::cpp::compute::region_network_firewall_policies::v1::
          PatchRegionNetworkFirewallPoliciesRequest const& request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  PatchRule(google::cloud::cpp::compute::region_network_firewall_policies::v1::
                PatchRuleRequest const& request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  RemoveAssociation(
      google::cloud::cpp::compute::region_network_firewall_policies::v1::
          RemoveAssociationRequest const& request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  RemoveRule(google::cloud::cpp::compute::region_network_firewall_policies::v1::
                 RemoveRuleRequest const& request);

  virtual StatusOr<google::cloud::cpp::compute::v1::Policy> SetIamPolicy(
      google::cloud::cpp::compute::region_network_firewall_policies::v1::
          SetIamPolicyRequest const& request);

  virtual StatusOr<google::cloud::cpp::compute::v1::TestPermissionsResponse>
  TestIamPermissions(
      google::cloud::cpp::compute::region_network_firewall_policies::v1::
          TestIamPermissionsRequest const& request);
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_region_network_firewall_policies_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_REGION_NETWORK_FIREWALL_POLICIES_V1_REGION_NETWORK_FIREWALL_POLICIES_CONNECTION_H
