// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/region_url_maps/v1/region_url_maps.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_REGION_URL_MAPS_V1_REGION_URL_MAPS_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_REGION_URL_MAPS_V1_REGION_URL_MAPS_CONNECTION_H

#include "google/cloud/compute/region_url_maps/v1/internal/region_url_maps_retry_traits.h"
#include "google/cloud/compute/region_url_maps/v1/region_url_maps_connection_idempotency_policy.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/experimental_tag.h"
#include "google/cloud/future.h"
#include "google/cloud/options.h"
#include "google/cloud/polling_policy.h"
#include "google/cloud/status_or.h"
#include "google/cloud/stream_range.h"
#include "google/cloud/version.h"
#include <google/cloud/compute/region_url_maps/v1/region_url_maps.pb.h>
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace compute_region_url_maps_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using RegionUrlMapsRetryPolicy =
    ::google::cloud::internal::TraitBasedRetryPolicy<
        compute_region_url_maps_v1_internal::RegionUrlMapsRetryTraits>;

using RegionUrlMapsLimitedTimeRetryPolicy =
    ::google::cloud::internal::LimitedTimeRetryPolicy<
        compute_region_url_maps_v1_internal::RegionUrlMapsRetryTraits>;

using RegionUrlMapsLimitedErrorCountRetryPolicy =
    ::google::cloud::internal::LimitedErrorCountRetryPolicy<
        compute_region_url_maps_v1_internal::RegionUrlMapsRetryTraits>;

/**
 * The `RegionUrlMapsConnection` object for `RegionUrlMapsClient`.
 *
 * This interface defines virtual methods for each of the user-facing overload
 * sets in `RegionUrlMapsClient`. This allows users to inject custom behavior
 * (e.g., with a Google Mock object) when writing tests that use objects of type
 * `RegionUrlMapsClient`.
 *
 * To create a concrete instance, see `MakeRegionUrlMapsConnection()`.
 *
 * For mocking, see
 * `compute_region_url_maps_v1_mocks::MockRegionUrlMapsConnection`.
 */
class RegionUrlMapsConnection {
 public:
  virtual ~RegionUrlMapsConnection() = 0;

  virtual Options options() { return Options{}; }

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  DeleteRegionUrlMaps(google::cloud::cpp::compute::region_url_maps::v1::
                          DeleteRegionUrlMapsRequest const& request);

  virtual StatusOr<google::cloud::cpp::compute::v1::UrlMap> GetRegionUrlMaps(
      google::cloud::cpp::compute::region_url_maps::v1::
          GetRegionUrlMapsRequest const& request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  InsertRegionUrlMaps(google::cloud::cpp::compute::region_url_maps::v1::
                          InsertRegionUrlMapsRequest const& request);

  virtual StreamRange<google::cloud::cpp::compute::v1::UrlMap>
  ListRegionUrlMaps(
      google::cloud::cpp::compute::region_url_maps::v1::ListRegionUrlMapsRequest
          request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  PatchRegionUrlMaps(google::cloud::cpp::compute::region_url_maps::v1::
                         PatchRegionUrlMapsRequest const& request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  UpdateRegionUrlMaps(google::cloud::cpp::compute::region_url_maps::v1::
                          UpdateRegionUrlMapsRequest const& request);

  virtual StatusOr<google::cloud::cpp::compute::v1::UrlMapsValidateResponse>
  Validate(
      google::cloud::cpp::compute::region_url_maps::v1::ValidateRequest const&
          request);
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_region_url_maps_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_REGION_URL_MAPS_V1_REGION_URL_MAPS_CONNECTION_H
