// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/routers/v1/routers.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_ROUTERS_V1_ROUTERS_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_ROUTERS_V1_ROUTERS_CONNECTION_H

#include "google/cloud/compute/routers/v1/internal/routers_retry_traits.h"
#include "google/cloud/compute/routers/v1/routers_connection_idempotency_policy.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/experimental_tag.h"
#include "google/cloud/future.h"
#include "google/cloud/options.h"
#include "google/cloud/polling_policy.h"
#include "google/cloud/status_or.h"
#include "google/cloud/stream_range.h"
#include "google/cloud/version.h"
#include <google/cloud/compute/routers/v1/routers.pb.h>
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace compute_routers_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using RoutersRetryPolicy = ::google::cloud::internal::TraitBasedRetryPolicy<
    compute_routers_v1_internal::RoutersRetryTraits>;

using RoutersLimitedTimeRetryPolicy =
    ::google::cloud::internal::LimitedTimeRetryPolicy<
        compute_routers_v1_internal::RoutersRetryTraits>;

using RoutersLimitedErrorCountRetryPolicy =
    ::google::cloud::internal::LimitedErrorCountRetryPolicy<
        compute_routers_v1_internal::RoutersRetryTraits>;

/**
 * The `RoutersConnection` object for `RoutersClient`.
 *
 * This interface defines virtual methods for each of the user-facing overload
 * sets in `RoutersClient`. This allows users to inject custom behavior
 * (e.g., with a Google Mock object) when writing tests that use objects of type
 * `RoutersClient`.
 *
 * To create a concrete instance, see `MakeRoutersConnection()`.
 *
 * For mocking, see `compute_routers_v1_mocks::MockRoutersConnection`.
 */
class RoutersConnection {
 public:
  virtual ~RoutersConnection() = 0;

  virtual Options options() { return Options{}; }

  virtual StatusOr<google::cloud::cpp::compute::v1::RouterAggregatedList>
  AggregatedListRouters(google::cloud::cpp::compute::routers::v1::
                            AggregatedListRoutersRequest const& request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  DeleteRouters(
      google::cloud::cpp::compute::routers::v1::DeleteRoutersRequest const&
          request);

  virtual StatusOr<google::cloud::cpp::compute::v1::Router> GetRouters(
      google::cloud::cpp::compute::routers::v1::GetRoutersRequest const&
          request);

  virtual StatusOr<google::cloud::cpp::compute::v1::VmEndpointNatMappingsList>
  GetNatMappingInfo(
      google::cloud::cpp::compute::routers::v1::GetNatMappingInfoRequest const&
          request);

  virtual StatusOr<google::cloud::cpp::compute::v1::RouterStatusResponse>
  GetRouterStatus(
      google::cloud::cpp::compute::routers::v1::GetRouterStatusRequest const&
          request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  InsertRouters(
      google::cloud::cpp::compute::routers::v1::InsertRoutersRequest const&
          request);

  virtual StreamRange<google::cloud::cpp::compute::v1::Router> ListRouters(
      google::cloud::cpp::compute::routers::v1::ListRoutersRequest request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  PatchRouters(
      google::cloud::cpp::compute::routers::v1::PatchRoutersRequest const&
          request);

  virtual StatusOr<google::cloud::cpp::compute::v1::RoutersPreviewResponse>
  Preview(
      google::cloud::cpp::compute::routers::v1::PreviewRequest const& request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  UpdateRouters(
      google::cloud::cpp::compute::routers::v1::UpdateRoutersRequest const&
          request);
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_routers_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_ROUTERS_V1_ROUTERS_CONNECTION_H
