// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/service_attachments/v1/service_attachments.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_SERVICE_ATTACHMENTS_V1_SERVICE_ATTACHMENTS_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_SERVICE_ATTACHMENTS_V1_SERVICE_ATTACHMENTS_CONNECTION_H

#include "google/cloud/compute/service_attachments/v1/internal/service_attachments_retry_traits.h"
#include "google/cloud/compute/service_attachments/v1/service_attachments_connection_idempotency_policy.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/experimental_tag.h"
#include "google/cloud/future.h"
#include "google/cloud/options.h"
#include "google/cloud/polling_policy.h"
#include "google/cloud/status_or.h"
#include "google/cloud/stream_range.h"
#include "google/cloud/version.h"
#include <google/cloud/compute/service_attachments/v1/service_attachments.pb.h>
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace compute_service_attachments_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ServiceAttachmentsRetryPolicy =
    ::google::cloud::internal::TraitBasedRetryPolicy<
        compute_service_attachments_v1_internal::ServiceAttachmentsRetryTraits>;

using ServiceAttachmentsLimitedTimeRetryPolicy =
    ::google::cloud::internal::LimitedTimeRetryPolicy<
        compute_service_attachments_v1_internal::ServiceAttachmentsRetryTraits>;

using ServiceAttachmentsLimitedErrorCountRetryPolicy =
    ::google::cloud::internal::LimitedErrorCountRetryPolicy<
        compute_service_attachments_v1_internal::ServiceAttachmentsRetryTraits>;

/**
 * The `ServiceAttachmentsConnection` object for `ServiceAttachmentsClient`.
 *
 * This interface defines virtual methods for each of the user-facing overload
 * sets in `ServiceAttachmentsClient`. This allows users to inject custom
 * behavior (e.g., with a Google Mock object) when writing tests that use
 * objects of type `ServiceAttachmentsClient`.
 *
 * To create a concrete instance, see `MakeServiceAttachmentsConnection()`.
 *
 * For mocking, see
 * `compute_service_attachments_v1_mocks::MockServiceAttachmentsConnection`.
 */
class ServiceAttachmentsConnection {
 public:
  virtual ~ServiceAttachmentsConnection() = 0;

  virtual Options options() { return Options{}; }

  virtual StatusOr<
      google::cloud::cpp::compute::v1::ServiceAttachmentAggregatedList>
  AggregatedListServiceAttachments(
      google::cloud::cpp::compute::service_attachments::v1::
          AggregatedListServiceAttachmentsRequest const& request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  DeleteServiceAttachments(
      google::cloud::cpp::compute::service_attachments::v1::
          DeleteServiceAttachmentsRequest const& request);

  virtual StatusOr<google::cloud::cpp::compute::v1::ServiceAttachment>
  GetServiceAttachments(google::cloud::cpp::compute::service_attachments::v1::
                            GetServiceAttachmentsRequest const& request);

  virtual StatusOr<google::cloud::cpp::compute::v1::Policy> GetIamPolicy(
      google::cloud::cpp::compute::service_attachments::v1::
          GetIamPolicyRequest const& request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  InsertServiceAttachments(
      google::cloud::cpp::compute::service_attachments::v1::
          InsertServiceAttachmentsRequest const& request);

  virtual StreamRange<google::cloud::cpp::compute::v1::ServiceAttachment>
  ListServiceAttachments(google::cloud::cpp::compute::service_attachments::v1::
                             ListServiceAttachmentsRequest request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  PatchServiceAttachments(google::cloud::cpp::compute::service_attachments::v1::
                              PatchServiceAttachmentsRequest const& request);

  virtual StatusOr<google::cloud::cpp::compute::v1::Policy> SetIamPolicy(
      google::cloud::cpp::compute::service_attachments::v1::
          SetIamPolicyRequest const& request);

  virtual StatusOr<google::cloud::cpp::compute::v1::TestPermissionsResponse>
  TestIamPermissions(google::cloud::cpp::compute::service_attachments::v1::
                         TestIamPermissionsRequest const& request);
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_service_attachments_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_SERVICE_ATTACHMENTS_V1_SERVICE_ATTACHMENTS_CONNECTION_H
