// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/ssl_policies/v1/ssl_policies.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_SSL_POLICIES_V1_SSL_POLICIES_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_SSL_POLICIES_V1_SSL_POLICIES_CONNECTION_H

#include "google/cloud/compute/ssl_policies/v1/internal/ssl_policies_retry_traits.h"
#include "google/cloud/compute/ssl_policies/v1/ssl_policies_connection_idempotency_policy.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/experimental_tag.h"
#include "google/cloud/future.h"
#include "google/cloud/options.h"
#include "google/cloud/polling_policy.h"
#include "google/cloud/status_or.h"
#include "google/cloud/stream_range.h"
#include "google/cloud/version.h"
#include <google/cloud/compute/ssl_policies/v1/ssl_policies.pb.h>
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace compute_ssl_policies_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using SslPoliciesRetryPolicy = ::google::cloud::internal::TraitBasedRetryPolicy<
    compute_ssl_policies_v1_internal::SslPoliciesRetryTraits>;

using SslPoliciesLimitedTimeRetryPolicy =
    ::google::cloud::internal::LimitedTimeRetryPolicy<
        compute_ssl_policies_v1_internal::SslPoliciesRetryTraits>;

using SslPoliciesLimitedErrorCountRetryPolicy =
    ::google::cloud::internal::LimitedErrorCountRetryPolicy<
        compute_ssl_policies_v1_internal::SslPoliciesRetryTraits>;

/**
 * The `SslPoliciesConnection` object for `SslPoliciesClient`.
 *
 * This interface defines virtual methods for each of the user-facing overload
 * sets in `SslPoliciesClient`. This allows users to inject custom behavior
 * (e.g., with a Google Mock object) when writing tests that use objects of type
 * `SslPoliciesClient`.
 *
 * To create a concrete instance, see `MakeSslPoliciesConnection()`.
 *
 * For mocking, see `compute_ssl_policies_v1_mocks::MockSslPoliciesConnection`.
 */
class SslPoliciesConnection {
 public:
  virtual ~SslPoliciesConnection() = 0;

  virtual Options options() { return Options{}; }

  virtual StatusOr<google::cloud::cpp::compute::v1::SslPoliciesAggregatedList>
  AggregatedListSslPolicies(
      google::cloud::cpp::compute::ssl_policies::v1::
          AggregatedListSslPoliciesRequest const& request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  DeleteSslPolicies(google::cloud::cpp::compute::ssl_policies::v1::
                        DeleteSslPoliciesRequest const& request);

  virtual StatusOr<google::cloud::cpp::compute::v1::SslPolicy> GetSslPolicies(
      google::cloud::cpp::compute::ssl_policies::v1::
          GetSslPoliciesRequest const& request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  InsertSslPolicies(google::cloud::cpp::compute::ssl_policies::v1::
                        InsertSslPoliciesRequest const& request);

  virtual StreamRange<google::cloud::cpp::compute::v1::SslPolicy>
  ListSslPolicies(
      google::cloud::cpp::compute::ssl_policies::v1::ListSslPoliciesRequest
          request);

  virtual StatusOr<
      google::cloud::cpp::compute::v1::SslPoliciesListAvailableFeaturesResponse>
  ListAvailableFeatures(google::cloud::cpp::compute::ssl_policies::v1::
                            ListAvailableFeaturesRequest const& request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  PatchSslPolicies(google::cloud::cpp::compute::ssl_policies::v1::
                       PatchSslPoliciesRequest const& request);
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_ssl_policies_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_SSL_POLICIES_V1_SSL_POLICIES_CONNECTION_H
