// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/target_instances/v1/target_instances.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_TARGET_INSTANCES_V1_TARGET_INSTANCES_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_TARGET_INSTANCES_V1_TARGET_INSTANCES_CONNECTION_H

#include "google/cloud/compute/target_instances/v1/internal/target_instances_retry_traits.h"
#include "google/cloud/compute/target_instances/v1/target_instances_connection_idempotency_policy.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/experimental_tag.h"
#include "google/cloud/future.h"
#include "google/cloud/options.h"
#include "google/cloud/polling_policy.h"
#include "google/cloud/status_or.h"
#include "google/cloud/stream_range.h"
#include "google/cloud/version.h"
#include <google/cloud/compute/target_instances/v1/target_instances.pb.h>
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace compute_target_instances_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using TargetInstancesRetryPolicy =
    ::google::cloud::internal::TraitBasedRetryPolicy<
        compute_target_instances_v1_internal::TargetInstancesRetryTraits>;

using TargetInstancesLimitedTimeRetryPolicy =
    ::google::cloud::internal::LimitedTimeRetryPolicy<
        compute_target_instances_v1_internal::TargetInstancesRetryTraits>;

using TargetInstancesLimitedErrorCountRetryPolicy =
    ::google::cloud::internal::LimitedErrorCountRetryPolicy<
        compute_target_instances_v1_internal::TargetInstancesRetryTraits>;

/**
 * The `TargetInstancesConnection` object for `TargetInstancesClient`.
 *
 * This interface defines virtual methods for each of the user-facing overload
 * sets in `TargetInstancesClient`. This allows users to inject custom behavior
 * (e.g., with a Google Mock object) when writing tests that use objects of type
 * `TargetInstancesClient`.
 *
 * To create a concrete instance, see `MakeTargetInstancesConnection()`.
 *
 * For mocking, see
 * `compute_target_instances_v1_mocks::MockTargetInstancesConnection`.
 */
class TargetInstancesConnection {
 public:
  virtual ~TargetInstancesConnection() = 0;

  virtual Options options() { return Options{}; }

  virtual StatusOr<
      google::cloud::cpp::compute::v1::TargetInstanceAggregatedList>
  AggregatedListTargetInstances(
      google::cloud::cpp::compute::target_instances::v1::
          AggregatedListTargetInstancesRequest const& request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  DeleteTargetInstances(google::cloud::cpp::compute::target_instances::v1::
                            DeleteTargetInstancesRequest const& request);

  virtual StatusOr<google::cloud::cpp::compute::v1::TargetInstance>
  GetTargetInstances(google::cloud::cpp::compute::target_instances::v1::
                         GetTargetInstancesRequest const& request);

  virtual future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  InsertTargetInstances(google::cloud::cpp::compute::target_instances::v1::
                            InsertTargetInstancesRequest const& request);

  virtual StreamRange<google::cloud::cpp::compute::v1::TargetInstance>
  ListTargetInstances(google::cloud::cpp::compute::target_instances::v1::
                          ListTargetInstancesRequest request);
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_target_instances_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_TARGET_INSTANCES_V1_TARGET_INSTANCES_CONNECTION_H
