// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/contentwarehouse/v1/ruleset_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_CONTENTWAREHOUSE_V1_RULE_SET_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_CONTENTWAREHOUSE_V1_RULE_SET_CONNECTION_H

#include "google/cloud/contentwarehouse/v1/internal/rule_set_retry_traits.h"
#include "google/cloud/contentwarehouse/v1/rule_set_connection_idempotency_policy.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/options.h"
#include "google/cloud/status_or.h"
#include "google/cloud/stream_range.h"
#include "google/cloud/version.h"
#include <google/cloud/contentwarehouse/v1/ruleset_service.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace contentwarehouse_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using RuleSetServiceRetryPolicy =
    ::google::cloud::internal::TraitBasedRetryPolicy<
        contentwarehouse_v1_internal::RuleSetServiceRetryTraits>;

using RuleSetServiceLimitedTimeRetryPolicy =
    ::google::cloud::internal::LimitedTimeRetryPolicy<
        contentwarehouse_v1_internal::RuleSetServiceRetryTraits>;

using RuleSetServiceLimitedErrorCountRetryPolicy =
    ::google::cloud::internal::LimitedErrorCountRetryPolicy<
        contentwarehouse_v1_internal::RuleSetServiceRetryTraits>;

/**
 * The `RuleSetServiceConnection` object for `RuleSetServiceClient`.
 *
 * This interface defines virtual methods for each of the user-facing overload
 * sets in `RuleSetServiceClient`. This allows users to inject custom behavior
 * (e.g., with a Google Mock object) when writing tests that use objects of type
 * `RuleSetServiceClient`.
 *
 * To create a concrete instance, see `MakeRuleSetServiceConnection()`.
 *
 * For mocking, see `contentwarehouse_v1_mocks::MockRuleSetServiceConnection`.
 */
class RuleSetServiceConnection {
 public:
  virtual ~RuleSetServiceConnection() = 0;

  virtual Options options() { return Options{}; }

  virtual StatusOr<google::cloud::contentwarehouse::v1::RuleSet> CreateRuleSet(
      google::cloud::contentwarehouse::v1::CreateRuleSetRequest const& request);

  virtual StatusOr<google::cloud::contentwarehouse::v1::RuleSet> GetRuleSet(
      google::cloud::contentwarehouse::v1::GetRuleSetRequest const& request);

  virtual StatusOr<google::cloud::contentwarehouse::v1::RuleSet> UpdateRuleSet(
      google::cloud::contentwarehouse::v1::UpdateRuleSetRequest const& request);

  virtual Status DeleteRuleSet(
      google::cloud::contentwarehouse::v1::DeleteRuleSetRequest const& request);

  virtual StreamRange<google::cloud::contentwarehouse::v1::RuleSet>
  ListRuleSets(
      google::cloud::contentwarehouse::v1::ListRuleSetsRequest request);
};

/**
 * A factory function to construct an object of type `RuleSetServiceConnection`.
 *
 * The returned connection object should not be used directly; instead it
 * should be passed as an argument to the constructor of RuleSetServiceClient.
 *
 * The optional @p options argument may be used to configure aspects of the
 * returned `RuleSetServiceConnection`. Expected options are any of the types in
 * the following option lists:
 *
 * - `google::cloud::CommonOptionList`
 * - `google::cloud::GrpcOptionList`
 * - `google::cloud::UnifiedCredentialsOptionList`
 * - `google::cloud::contentwarehouse_v1::RuleSetServicePolicyOptionList`
 *
 * @note Unexpected options will be ignored. To log unexpected options instead,
 *     set `GOOGLE_CLOUD_CPP_ENABLE_CLOG=yes` in the environment.
 *
 * @param options (optional) Configure the `RuleSetServiceConnection` created by
 * this function.
 */
std::shared_ptr<RuleSetServiceConnection> MakeRuleSetServiceConnection(
    Options options = {});

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace contentwarehouse_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_CONTENTWAREHOUSE_V1_RULE_SET_CONNECTION_H
