// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/gaming/v1/game_server_deployments_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_GAMESERVICES_V1_GAME_SERVER_DEPLOYMENTS_OPTIONS_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_GAMESERVICES_V1_GAME_SERVER_DEPLOYMENTS_OPTIONS_H

#include "google/cloud/gameservices/v1/game_server_deployments_connection.h"
#include "google/cloud/gameservices/v1/game_server_deployments_connection_idempotency_policy.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/options.h"
#include "google/cloud/version.h"
#include <memory>

namespace google {
namespace cloud {
namespace gameservices_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

/**
 * Use with `google::cloud::Options` to configure the retry policy.
 *
 * @ingroup google-cloud-gameservices-options
 */
struct GameServerDeploymentsServiceRetryPolicyOption {
  using Type = std::shared_ptr<GameServerDeploymentsServiceRetryPolicy>;
};

/**
 * Use with `google::cloud::Options` to configure the backoff policy.
 *
 * @ingroup google-cloud-gameservices-options
 */
struct GameServerDeploymentsServiceBackoffPolicyOption {
  using Type = std::shared_ptr<BackoffPolicy>;
};

/**
 * Use with `google::cloud::Options` to configure which operations are retried.
 *
 * @ingroup google-cloud-gameservices-options
 */
struct GameServerDeploymentsServiceConnectionIdempotencyPolicyOption {
  using Type =
      std::shared_ptr<GameServerDeploymentsServiceConnectionIdempotencyPolicy>;
};

/**
 * Use with `google::cloud::Options` to configure the long-running operations
 * polling policy.
 *
 * @ingroup google-cloud-gameservices-options
 */
struct GameServerDeploymentsServicePollingPolicyOption {
  using Type = std::shared_ptr<PollingPolicy>;
};

/**
 * The options applicable to GameServerDeploymentsService.
 *
 * @ingroup google-cloud-gameservices-options
 */
using GameServerDeploymentsServicePolicyOptionList =
    OptionList<GameServerDeploymentsServiceRetryPolicyOption,
               GameServerDeploymentsServiceBackoffPolicyOption,
               GameServerDeploymentsServicePollingPolicyOption,
               GameServerDeploymentsServiceConnectionIdempotencyPolicyOption>;

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace gameservices_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_GAMESERVICES_V1_GAME_SERVER_DEPLOYMENTS_OPTIONS_H
