// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/gaming/v1/game_server_clusters_service.proto

#include "google/cloud/gameservices/v1/internal/game_server_clusters_tracing_connection.h"
#include "google/cloud/internal/opentelemetry.h"
#include "google/cloud/internal/traced_stream_range.h"
#include <memory>

namespace google {
namespace cloud {
namespace gameservices_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

GameServerClustersServiceTracingConnection::
    GameServerClustersServiceTracingConnection(
        std::shared_ptr<gameservices_v1::GameServerClustersServiceConnection>
            child)
    : child_(std::move(child)) {}

StreamRange<google::cloud::gaming::v1::GameServerCluster>
GameServerClustersServiceTracingConnection::ListGameServerClusters(
    google::cloud::gaming::v1::ListGameServerClustersRequest request) {
  auto span = internal::MakeSpan(
      "gameservices_v1::GameServerClustersServiceConnection::"
      "ListGameServerClusters");
  auto scope = opentelemetry::trace::Scope(span);
  auto sr = child_->ListGameServerClusters(std::move(request));
  return internal::MakeTracedStreamRange<
      google::cloud::gaming::v1::GameServerCluster>(std::move(span),
                                                    std::move(sr));
}

StatusOr<google::cloud::gaming::v1::GameServerCluster>
GameServerClustersServiceTracingConnection::GetGameServerCluster(
    google::cloud::gaming::v1::GetGameServerClusterRequest const& request) {
  auto span = internal::MakeSpan(
      "gameservices_v1::GameServerClustersServiceConnection::"
      "GetGameServerCluster");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span, child_->GetGameServerCluster(request));
}

future<StatusOr<google::cloud::gaming::v1::GameServerCluster>>
GameServerClustersServiceTracingConnection::CreateGameServerCluster(
    google::cloud::gaming::v1::CreateGameServerClusterRequest const& request) {
  auto span = internal::MakeSpan(
      "gameservices_v1::GameServerClustersServiceConnection::"
      "CreateGameServerCluster");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(std::move(span),
                           child_->CreateGameServerCluster(request));
}

StatusOr<google::cloud::gaming::v1::PreviewCreateGameServerClusterResponse>
GameServerClustersServiceTracingConnection::PreviewCreateGameServerCluster(
    google::cloud::gaming::v1::PreviewCreateGameServerClusterRequest const&
        request) {
  auto span = internal::MakeSpan(
      "gameservices_v1::GameServerClustersServiceConnection::"
      "PreviewCreateGameServerCluster");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span,
                           child_->PreviewCreateGameServerCluster(request));
}

future<StatusOr<google::cloud::gaming::v1::OperationMetadata>>
GameServerClustersServiceTracingConnection::DeleteGameServerCluster(
    google::cloud::gaming::v1::DeleteGameServerClusterRequest const& request) {
  auto span = internal::MakeSpan(
      "gameservices_v1::GameServerClustersServiceConnection::"
      "DeleteGameServerCluster");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(std::move(span),
                           child_->DeleteGameServerCluster(request));
}

StatusOr<google::cloud::gaming::v1::PreviewDeleteGameServerClusterResponse>
GameServerClustersServiceTracingConnection::PreviewDeleteGameServerCluster(
    google::cloud::gaming::v1::PreviewDeleteGameServerClusterRequest const&
        request) {
  auto span = internal::MakeSpan(
      "gameservices_v1::GameServerClustersServiceConnection::"
      "PreviewDeleteGameServerCluster");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span,
                           child_->PreviewDeleteGameServerCluster(request));
}

future<StatusOr<google::cloud::gaming::v1::GameServerCluster>>
GameServerClustersServiceTracingConnection::UpdateGameServerCluster(
    google::cloud::gaming::v1::UpdateGameServerClusterRequest const& request) {
  auto span = internal::MakeSpan(
      "gameservices_v1::GameServerClustersServiceConnection::"
      "UpdateGameServerCluster");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(std::move(span),
                           child_->UpdateGameServerCluster(request));
}

StatusOr<google::cloud::gaming::v1::PreviewUpdateGameServerClusterResponse>
GameServerClustersServiceTracingConnection::PreviewUpdateGameServerCluster(
    google::cloud::gaming::v1::PreviewUpdateGameServerClusterRequest const&
        request) {
  auto span = internal::MakeSpan(
      "gameservices_v1::GameServerClustersServiceConnection::"
      "PreviewUpdateGameServerCluster");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span,
                           child_->PreviewUpdateGameServerCluster(request));
}

#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

std::shared_ptr<gameservices_v1::GameServerClustersServiceConnection>
MakeGameServerClustersServiceTracingConnection(
    std::shared_ptr<gameservices_v1::GameServerClustersServiceConnection>
        conn) {
#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  if (internal::TracingEnabled(conn->options())) {
    conn = std::make_shared<GameServerClustersServiceTracingConnection>(
        std::move(conn));
  }
#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  return conn;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace gameservices_v1_internal
}  // namespace cloud
}  // namespace google
