// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/gaming/v1/game_server_configs_service.proto

#include "google/cloud/gameservices/v1/internal/game_server_configs_tracing_connection.h"
#include "google/cloud/internal/opentelemetry.h"
#include "google/cloud/internal/traced_stream_range.h"
#include <memory>

namespace google {
namespace cloud {
namespace gameservices_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

GameServerConfigsServiceTracingConnection::
    GameServerConfigsServiceTracingConnection(
        std::shared_ptr<gameservices_v1::GameServerConfigsServiceConnection>
            child)
    : child_(std::move(child)) {}

StreamRange<google::cloud::gaming::v1::GameServerConfig>
GameServerConfigsServiceTracingConnection::ListGameServerConfigs(
    google::cloud::gaming::v1::ListGameServerConfigsRequest request) {
  auto span = internal::MakeSpan(
      "gameservices_v1::GameServerConfigsServiceConnection::"
      "ListGameServerConfigs");
  auto scope = opentelemetry::trace::Scope(span);
  auto sr = child_->ListGameServerConfigs(std::move(request));
  return internal::MakeTracedStreamRange<
      google::cloud::gaming::v1::GameServerConfig>(std::move(span),
                                                   std::move(sr));
}

StatusOr<google::cloud::gaming::v1::GameServerConfig>
GameServerConfigsServiceTracingConnection::GetGameServerConfig(
    google::cloud::gaming::v1::GetGameServerConfigRequest const& request) {
  auto span = internal::MakeSpan(
      "gameservices_v1::GameServerConfigsServiceConnection::"
      "GetGameServerConfig");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span, child_->GetGameServerConfig(request));
}

future<StatusOr<google::cloud::gaming::v1::GameServerConfig>>
GameServerConfigsServiceTracingConnection::CreateGameServerConfig(
    google::cloud::gaming::v1::CreateGameServerConfigRequest const& request) {
  auto span = internal::MakeSpan(
      "gameservices_v1::GameServerConfigsServiceConnection::"
      "CreateGameServerConfig");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(std::move(span),
                           child_->CreateGameServerConfig(request));
}

future<StatusOr<google::cloud::gaming::v1::OperationMetadata>>
GameServerConfigsServiceTracingConnection::DeleteGameServerConfig(
    google::cloud::gaming::v1::DeleteGameServerConfigRequest const& request) {
  auto span = internal::MakeSpan(
      "gameservices_v1::GameServerConfigsServiceConnection::"
      "DeleteGameServerConfig");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(std::move(span),
                           child_->DeleteGameServerConfig(request));
}

#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

std::shared_ptr<gameservices_v1::GameServerConfigsServiceConnection>
MakeGameServerConfigsServiceTracingConnection(
    std::shared_ptr<gameservices_v1::GameServerConfigsServiceConnection> conn) {
#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  if (internal::TracingEnabled(conn->options())) {
    conn = std::make_shared<GameServerConfigsServiceTracingConnection>(
        std::move(conn));
  }
#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  return conn;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace gameservices_v1_internal
}  // namespace cloud
}  // namespace google
