// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/gaming/v1/game_server_deployments_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_GAMESERVICES_V1_INTERNAL_GAME_SERVER_DEPLOYMENTS_CONNECTION_IMPL_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_GAMESERVICES_V1_INTERNAL_GAME_SERVER_DEPLOYMENTS_CONNECTION_IMPL_H

#include "google/cloud/gameservices/v1/game_server_deployments_connection.h"
#include "google/cloud/gameservices/v1/game_server_deployments_connection_idempotency_policy.h"
#include "google/cloud/gameservices/v1/game_server_deployments_options.h"
#include "google/cloud/gameservices/v1/internal/game_server_deployments_retry_traits.h"
#include "google/cloud/gameservices/v1/internal/game_server_deployments_stub.h"
#include "google/cloud/background_threads.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/future.h"
#include "google/cloud/options.h"
#include "google/cloud/polling_policy.h"
#include "google/cloud/status_or.h"
#include "google/cloud/stream_range.h"
#include "google/cloud/version.h"
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace gameservices_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class GameServerDeploymentsServiceConnectionImpl
    : public gameservices_v1::GameServerDeploymentsServiceConnection {
 public:
  ~GameServerDeploymentsServiceConnectionImpl() override = default;

  GameServerDeploymentsServiceConnectionImpl(
      std::unique_ptr<google::cloud::BackgroundThreads> background,
      std::shared_ptr<
          gameservices_v1_internal::GameServerDeploymentsServiceStub>
          stub,
      Options options);

  Options options() override { return options_; }

  StreamRange<google::cloud::gaming::v1::GameServerDeployment>
  ListGameServerDeployments(
      google::cloud::gaming::v1::ListGameServerDeploymentsRequest request)
      override;

  StatusOr<google::cloud::gaming::v1::GameServerDeployment>
  GetGameServerDeployment(
      google::cloud::gaming::v1::GetGameServerDeploymentRequest const& request)
      override;

  future<StatusOr<google::cloud::gaming::v1::GameServerDeployment>>
  CreateGameServerDeployment(
      google::cloud::gaming::v1::CreateGameServerDeploymentRequest const&
          request) override;

  future<StatusOr<google::cloud::gaming::v1::OperationMetadata>>
  DeleteGameServerDeployment(
      google::cloud::gaming::v1::DeleteGameServerDeploymentRequest const&
          request) override;

  future<StatusOr<google::cloud::gaming::v1::GameServerDeployment>>
  UpdateGameServerDeployment(
      google::cloud::gaming::v1::UpdateGameServerDeploymentRequest const&
          request) override;

  StatusOr<google::cloud::gaming::v1::GameServerDeploymentRollout>
  GetGameServerDeploymentRollout(
      google::cloud::gaming::v1::GetGameServerDeploymentRolloutRequest const&
          request) override;

  future<StatusOr<google::cloud::gaming::v1::GameServerDeployment>>
  UpdateGameServerDeploymentRollout(
      google::cloud::gaming::v1::UpdateGameServerDeploymentRolloutRequest const&
          request) override;

  StatusOr<
      google::cloud::gaming::v1::PreviewGameServerDeploymentRolloutResponse>
  PreviewGameServerDeploymentRollout(
      google::cloud::gaming::v1::
          PreviewGameServerDeploymentRolloutRequest const& request) override;

  StatusOr<google::cloud::gaming::v1::FetchDeploymentStateResponse>
  FetchDeploymentState(
      google::cloud::gaming::v1::FetchDeploymentStateRequest const& request)
      override;

 private:
  std::unique_ptr<gameservices_v1::GameServerDeploymentsServiceRetryPolicy>
  retry_policy() {
    auto const& options = internal::CurrentOptions();
    if (options.has<
            gameservices_v1::GameServerDeploymentsServiceRetryPolicyOption>()) {
      return options
          .get<gameservices_v1::GameServerDeploymentsServiceRetryPolicyOption>()
          ->clone();
    }
    return options_
        .get<gameservices_v1::GameServerDeploymentsServiceRetryPolicyOption>()
        ->clone();
  }

  std::unique_ptr<BackoffPolicy> backoff_policy() {
    auto const& options = internal::CurrentOptions();
    if (options.has<gameservices_v1::
                        GameServerDeploymentsServiceBackoffPolicyOption>()) {
      return options
          .get<gameservices_v1::
                   GameServerDeploymentsServiceBackoffPolicyOption>()
          ->clone();
    }
    return options_
        .get<gameservices_v1::GameServerDeploymentsServiceBackoffPolicyOption>()
        ->clone();
  }

  std::unique_ptr<
      gameservices_v1::GameServerDeploymentsServiceConnectionIdempotencyPolicy>
  idempotency_policy() {
    auto const& options = internal::CurrentOptions();
    if (options.has<
            gameservices_v1::
                GameServerDeploymentsServiceConnectionIdempotencyPolicyOption>()) {
      return options
          .get<
              gameservices_v1::
                  GameServerDeploymentsServiceConnectionIdempotencyPolicyOption>()
          ->clone();
    }
    return options_
        .get<
            gameservices_v1::
                GameServerDeploymentsServiceConnectionIdempotencyPolicyOption>()
        ->clone();
  }

  std::unique_ptr<PollingPolicy> polling_policy() {
    auto const& options = internal::CurrentOptions();
    if (options.has<gameservices_v1::
                        GameServerDeploymentsServicePollingPolicyOption>()) {
      return options
          .get<gameservices_v1::
                   GameServerDeploymentsServicePollingPolicyOption>()
          ->clone();
    }
    return options_
        .get<gameservices_v1::GameServerDeploymentsServicePollingPolicyOption>()
        ->clone();
  }

  std::unique_ptr<google::cloud::BackgroundThreads> background_;
  std::shared_ptr<gameservices_v1_internal::GameServerDeploymentsServiceStub>
      stub_;
  Options options_;
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace gameservices_v1_internal
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_GAMESERVICES_V1_INTERNAL_GAME_SERVER_DEPLOYMENTS_CONNECTION_IMPL_H
