// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/gaming/v1/realms_service.proto

#include "google/cloud/gameservices/v1/realms_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace gameservices_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

RealmsServiceConnectionIdempotencyPolicy::
    ~RealmsServiceConnectionIdempotencyPolicy() = default;

std::unique_ptr<RealmsServiceConnectionIdempotencyPolicy>
RealmsServiceConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<RealmsServiceConnectionIdempotencyPolicy>(*this);
}

Idempotency RealmsServiceConnectionIdempotencyPolicy::ListRealms(
    google::cloud::gaming::v1::ListRealmsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency RealmsServiceConnectionIdempotencyPolicy::GetRealm(
    google::cloud::gaming::v1::GetRealmRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency RealmsServiceConnectionIdempotencyPolicy::CreateRealm(
    google::cloud::gaming::v1::CreateRealmRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency RealmsServiceConnectionIdempotencyPolicy::DeleteRealm(
    google::cloud::gaming::v1::DeleteRealmRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency RealmsServiceConnectionIdempotencyPolicy::UpdateRealm(
    google::cloud::gaming::v1::UpdateRealmRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency RealmsServiceConnectionIdempotencyPolicy::PreviewRealmUpdate(
    google::cloud::gaming::v1::PreviewRealmUpdateRequest const&) {
  return Idempotency::kNonIdempotent;
}

std::unique_ptr<RealmsServiceConnectionIdempotencyPolicy>
MakeDefaultRealmsServiceConnectionIdempotencyPolicy() {
  return std::make_unique<RealmsServiceConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace gameservices_v1
}  // namespace cloud
}  // namespace google
