// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/monitoring/metricsscope/v1/metrics_scopes.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_MONITORING_METRICSSCOPE_V1_METRICS_SCOPES_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_MONITORING_METRICSSCOPE_V1_METRICS_SCOPES_CONNECTION_H

#include "google/cloud/monitoring/metricsscope/v1/internal/metrics_scopes_retry_traits.h"
#include "google/cloud/monitoring/metricsscope/v1/metrics_scopes_connection_idempotency_policy.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/future.h"
#include "google/cloud/options.h"
#include "google/cloud/polling_policy.h"
#include "google/cloud/status_or.h"
#include "google/cloud/version.h"
#include <google/longrunning/operations.grpc.pb.h>
#include <google/monitoring/metricsscope/v1/metrics_scopes.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace monitoring_metricsscope_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using MetricsScopesRetryPolicy =
    ::google::cloud::internal::TraitBasedRetryPolicy<
        monitoring_metricsscope_v1_internal::MetricsScopesRetryTraits>;

using MetricsScopesLimitedTimeRetryPolicy =
    ::google::cloud::internal::LimitedTimeRetryPolicy<
        monitoring_metricsscope_v1_internal::MetricsScopesRetryTraits>;

using MetricsScopesLimitedErrorCountRetryPolicy =
    ::google::cloud::internal::LimitedErrorCountRetryPolicy<
        monitoring_metricsscope_v1_internal::MetricsScopesRetryTraits>;

/**
 * The `MetricsScopesConnection` object for `MetricsScopesClient`.
 *
 * This interface defines virtual methods for each of the user-facing overload
 * sets in `MetricsScopesClient`. This allows users to inject custom behavior
 * (e.g., with a Google Mock object) when writing tests that use objects of type
 * `MetricsScopesClient`.
 *
 * To create a concrete instance, see `MakeMetricsScopesConnection()`.
 *
 * For mocking, see
 * `monitoring_metricsscope_v1_mocks::MockMetricsScopesConnection`.
 */
class MetricsScopesConnection {
 public:
  virtual ~MetricsScopesConnection() = 0;

  virtual Options options() { return Options{}; }

  virtual StatusOr<google::monitoring::metricsscope::v1::MetricsScope>
  GetMetricsScope(
      google::monitoring::metricsscope::v1::GetMetricsScopeRequest const&
          request);

  virtual StatusOr<google::monitoring::metricsscope::v1::
                       ListMetricsScopesByMonitoredProjectResponse>
  ListMetricsScopesByMonitoredProject(
      google::monitoring::metricsscope::v1::
          ListMetricsScopesByMonitoredProjectRequest const& request);

  virtual future<
      StatusOr<google::monitoring::metricsscope::v1::MonitoredProject>>
  CreateMonitoredProject(
      google::monitoring::metricsscope::v1::CreateMonitoredProjectRequest const&
          request);

  virtual future<
      StatusOr<google::monitoring::metricsscope::v1::OperationMetadata>>
  DeleteMonitoredProject(
      google::monitoring::metricsscope::v1::DeleteMonitoredProjectRequest const&
          request);
};

/**
 * A factory function to construct an object of type `MetricsScopesConnection`.
 *
 * The returned connection object should not be used directly; instead it
 * should be passed as an argument to the constructor of MetricsScopesClient.
 *
 * The optional @p options argument may be used to configure aspects of the
 * returned `MetricsScopesConnection`. Expected options are any of the types in
 * the following option lists:
 *
 * - `google::cloud::CommonOptionList`
 * - `google::cloud::GrpcOptionList`
 * - `google::cloud::UnifiedCredentialsOptionList`
 * - `google::cloud::monitoring_metricsscope_v1::MetricsScopesPolicyOptionList`
 *
 * @note Unexpected options will be ignored. To log unexpected options instead,
 *     set `GOOGLE_CLOUD_CPP_ENABLE_CLOG=yes` in the environment.
 *
 * @param options (optional) Configure the `MetricsScopesConnection` created by
 * this function.
 */
std::shared_ptr<MetricsScopesConnection> MakeMetricsScopesConnection(
    Options options = {});

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace monitoring_metricsscope_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_MONITORING_METRICSSCOPE_V1_METRICS_SCOPES_CONNECTION_H
