// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/support/v2/comment_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_SUPPORT_V2_COMMENT_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_SUPPORT_V2_COMMENT_CONNECTION_H

#include "google/cloud/support/v2/comment_connection_idempotency_policy.h"
#include "google/cloud/support/v2/internal/comment_retry_traits.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/options.h"
#include "google/cloud/status_or.h"
#include "google/cloud/stream_range.h"
#include "google/cloud/version.h"
#include <google/cloud/support/v2/comment_service.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace support_v2 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using CommentServiceRetryPolicy =
    ::google::cloud::internal::TraitBasedRetryPolicy<
        support_v2_internal::CommentServiceRetryTraits>;

using CommentServiceLimitedTimeRetryPolicy =
    ::google::cloud::internal::LimitedTimeRetryPolicy<
        support_v2_internal::CommentServiceRetryTraits>;

using CommentServiceLimitedErrorCountRetryPolicy =
    ::google::cloud::internal::LimitedErrorCountRetryPolicy<
        support_v2_internal::CommentServiceRetryTraits>;

/**
 * The `CommentServiceConnection` object for `CommentServiceClient`.
 *
 * This interface defines virtual methods for each of the user-facing overload
 * sets in `CommentServiceClient`. This allows users to inject custom behavior
 * (e.g., with a Google Mock object) when writing tests that use objects of type
 * `CommentServiceClient`.
 *
 * To create a concrete instance, see `MakeCommentServiceConnection()`.
 *
 * For mocking, see `support_v2_mocks::MockCommentServiceConnection`.
 */
class CommentServiceConnection {
 public:
  virtual ~CommentServiceConnection() = 0;

  virtual Options options() { return Options{}; }

  virtual StreamRange<google::cloud::support::v2::Comment> ListComments(
      google::cloud::support::v2::ListCommentsRequest request);

  virtual StatusOr<google::cloud::support::v2::Comment> CreateComment(
      google::cloud::support::v2::CreateCommentRequest const& request);
};

/**
 * A factory function to construct an object of type `CommentServiceConnection`.
 *
 * The returned connection object should not be used directly; instead it
 * should be passed as an argument to the constructor of CommentServiceClient.
 *
 * The optional @p options argument may be used to configure aspects of the
 * returned `CommentServiceConnection`. Expected options are any of the types in
 * the following option lists:
 *
 * - `google::cloud::CommonOptionList`
 * - `google::cloud::GrpcOptionList`
 * - `google::cloud::UnifiedCredentialsOptionList`
 * - `google::cloud::support_v2::CommentServicePolicyOptionList`
 *
 * @note Unexpected options will be ignored. To log unexpected options instead,
 *     set `GOOGLE_CLOUD_CPP_ENABLE_CLOG=yes` in the environment.
 *
 * @param options (optional) Configure the `CommentServiceConnection` created by
 * this function.
 */
std::shared_ptr<CommentServiceConnection> MakeCommentServiceConnection(
    Options options = {});

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace support_v2
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_SUPPORT_V2_COMMENT_CONNECTION_H
