// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/talent/v4/completion_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_TALENT_V4_COMPLETION_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_TALENT_V4_COMPLETION_CONNECTION_H

#include "google/cloud/talent/v4/completion_connection_idempotency_policy.h"
#include "google/cloud/talent/v4/internal/completion_retry_traits.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/options.h"
#include "google/cloud/status_or.h"
#include "google/cloud/version.h"
#include <google/cloud/talent/v4/completion_service.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace talent_v4 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using CompletionRetryPolicy = ::google::cloud::internal::TraitBasedRetryPolicy<
    talent_v4_internal::CompletionRetryTraits>;

using CompletionLimitedTimeRetryPolicy =
    ::google::cloud::internal::LimitedTimeRetryPolicy<
        talent_v4_internal::CompletionRetryTraits>;

using CompletionLimitedErrorCountRetryPolicy =
    ::google::cloud::internal::LimitedErrorCountRetryPolicy<
        talent_v4_internal::CompletionRetryTraits>;

/**
 * The `CompletionConnection` object for `CompletionClient`.
 *
 * This interface defines virtual methods for each of the user-facing overload
 * sets in `CompletionClient`. This allows users to inject custom behavior
 * (e.g., with a Google Mock object) when writing tests that use objects of type
 * `CompletionClient`.
 *
 * To create a concrete instance, see `MakeCompletionConnection()`.
 *
 * For mocking, see `talent_v4_mocks::MockCompletionConnection`.
 */
class CompletionConnection {
 public:
  virtual ~CompletionConnection() = 0;

  virtual Options options() { return Options{}; }

  virtual StatusOr<google::cloud::talent::v4::CompleteQueryResponse>
  CompleteQuery(google::cloud::talent::v4::CompleteQueryRequest const& request);
};

/**
 * A factory function to construct an object of type `CompletionConnection`.
 *
 * The returned connection object should not be used directly; instead it
 * should be passed as an argument to the constructor of CompletionClient.
 *
 * The optional @p options argument may be used to configure aspects of the
 * returned `CompletionConnection`. Expected options are any of the types in
 * the following option lists:
 *
 * - `google::cloud::CommonOptionList`
 * - `google::cloud::GrpcOptionList`
 * - `google::cloud::UnifiedCredentialsOptionList`
 * - `google::cloud::talent_v4::CompletionPolicyOptionList`
 *
 * @note Unexpected options will be ignored. To log unexpected options instead,
 *     set `GOOGLE_CLOUD_CPP_ENABLE_CLOG=yes` in the environment.
 *
 * @param options (optional) Configure the `CompletionConnection` created by
 * this function.
 */
std::shared_ptr<CompletionConnection> MakeCompletionConnection(
    Options options = {});

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace talent_v4
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_TALENT_V4_COMPLETION_CONNECTION_H
